// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class AuthAzureSAS : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkAuthAzureSASU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkAuthAzureSASU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_accessKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_accessKeyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_putAccessKeyW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_putAccessKeyW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureSASU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_stringToSignW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_stringToSignW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_putStringToSignW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_putStringToSignW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureSASU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_ClearW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureSASU_ClearW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_generateTokenW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureSASU_generateTokenW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureSASU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_SetNonTokenParamW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureSASU_SetNonTokenParamW(System.IntPtr pObj, string name, string value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureSASU_SetTokenParamW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureSASU_SetTokenParamW(System.IntPtr pObj, string name, string authParamName, string value);


		public AuthAzureSAS()
		{
			m_pObj = CkAuthAzureSASU_CreateW();
			m_needDisposal = true;
		}

		public AuthAzureSAS(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkAuthAzureSASU_DisposeW(p);
			}
		}

		~AuthAzureSAS()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = AuthAzureSAS
	/// <summary>
	/// This is the signing key (access key) that must be kept private. It is a base64
	/// string such as
	/// "abdTvCZFFoWUyre6erlNN+IOb9qhXgDsyhrxmZvpmxqFDwpl9oD0X9Fy0hIQa6L5UohznRLmkCtUYySO
	/// 4Y2eaw=="
	/// </summary>
	public string AccessKey
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_accessKeyW(m_pObj));
		}
		set
		{
			CkAuthAzureSASU_putAccessKeyW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkAuthAzureSASU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkAuthAzureSASU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthAzureSASU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Defines the format of the string to sign.
	/// 
	/// The format is specified as a comma-separated list of names. For example:
	/// 
	/// signedpermissions,signedstart,signedexpiry,canonicalizedresource,signedidentifier,signedIP,signedProtocol,signedversion,rscc,rscd,rsce,rscl,rsct
	/// This will result in an actual string-to-sign that is composed of the values for
	/// each name separated by newline (LF) chars. For example:
	/// signedpermissions + "\n" +  
	/// signedstart + "\n" +  
	/// signedexpiry + "\n" +  
	/// canonicalizedresource + "\n" +  
	/// signedidentifier + "\n" +  
	/// signedIP + "\n" +  
	/// signedProtocol + "\n" +  
	/// signedversion + "\n" +  
	/// rscc + "\n" +  
	/// rscd + "\n" +  
	/// rsce + "\n" +  
	/// rscl + "\n" +  
	/// rsct
	///
	/// </summary>
	public string StringToSign
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_stringToSignW(m_pObj));
		}
		set
		{
			CkAuthAzureSASU_putStringToSignW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkAuthAzureSASU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthAzureSASU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkAuthAzureSASU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Clears all params set by the methods SetNonTokenParam and SetTokenParam.
	/// </summary>
	public void Clear()
	{
		CkAuthAzureSASU_ClearW(m_pObj);
		return;
	}
	/// <summary>
	/// Generates and returns the SAS token based on the defined StringToSign and
	/// params.
	/// </summary>
	public string GenerateToken()
	{
		System.IntPtr result = CkAuthAzureSASU_generateTokenW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkAuthAzureSASU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds a non-token parameter name/value. This is a value that is included in the
	/// string to sign, but is NOT included as a parameter in the Authorization header.
	/// </summary>
	public bool SetNonTokenParam(string name, string value)
	{
		int result = CkAuthAzureSASU_SetNonTokenParamW(m_pObj, name, value);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds a token parameter name/value. This is a value that is included in the
	/// string to sign, and is also included as a parameter in the Authorization header.
	/// </summary>
	public bool SetTokenParam(string name, string authParamName, string value)
	{
		int result = CkAuthAzureSASU_SetTokenParamW(m_pObj, name, authParamName, value);
		return result == 0 ? false : true;
	}


	}
}

