// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class AuthUtil : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkAuthUtilU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkAuthUtilU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthUtilU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthUtilU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthUtilU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthUtilU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthUtilU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthUtilU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthUtilU_walmartSignatureW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthUtilU_walmartSignatureW(System.IntPtr pObj, string requestUrl, string consumerId, string privateKey, string requestMethod);


		public AuthUtil()
		{
			m_pObj = CkAuthUtilU_CreateW();
			m_needDisposal = true;
		}

		public AuthUtil(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkAuthUtilU_DisposeW(p);
			}
		}

		~AuthUtil()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = AuthUtil
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkAuthUtilU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkAuthUtilU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkAuthUtilU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkAuthUtilU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkAuthUtilU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkAuthUtilU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthUtilU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkAuthUtilU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthUtilU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkAuthUtilU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkAuthUtilU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Generates a Walmart authentication signature for Walmart REST API calls. Returns
	/// a JSON string that contains both the WM_SEC_AUTH_SIGNATURE and WM_SEC.TIMESTAMP.
	/// </summary>
	public string WalmartSignature(string requestUrl, string consumerId, string privateKey, string requestMethod)
	{
		System.IntPtr result = CkAuthUtilU_walmartSignatureW(m_pObj, requestUrl, consumerId, privateKey, requestMethod);
		return ckFromUni(result);
	}


	}
}

