// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Cert : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkCertU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkCertU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_authorityKeyIdW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_authorityKeyIdW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getAvoidWindowsPkAccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getAvoidWindowsPkAccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putAvoidWindowsPkAccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putAvoidWindowsPkAccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getCertVersionW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getCertVersionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_cspNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_cspNameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getExpiredW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getExpiredW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_extendedKeyUsageW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_extendedKeyUsageW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getForClientAuthenticationW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getForClientAuthenticationW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getForCodeSigningW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getForCodeSigningW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getForSecureEmailW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getForSecureEmailW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getForServerAuthenticationW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getForServerAuthenticationW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getForTimeStampingW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getForTimeStampingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getHasKeyContainerW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getHasKeyContainerW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getIntendedKeyUsageW", CharSet = CharSet.Unicode)]
        private static extern uint CkCertU_getIntendedKeyUsageW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getIsRootW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getIsRootW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerCW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerCNW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerCNW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerDNW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerDNW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerEW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerEW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerLW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerLW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerOW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerOW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerOUW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerOUW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_issuerSW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_issuerSW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_keyContainerNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_keyContainerNameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getMachineKeysetW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getMachineKeysetW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ocspUrlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_ocspUrlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getPrivateKeyExportableW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getPrivateKeyExportableW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getRevokedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getRevokedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_rfc822NameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_rfc822NameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSelfSignedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getSelfSignedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_serialDecimalW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_serialDecimalW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_serialNumberW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_serialNumberW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_sha1ThumbprintW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_sha1ThumbprintW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSignatureVerifiedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getSignatureVerifiedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSilentW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getSilentW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSmartCardNoDialogW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getSmartCardNoDialogW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putSmartCardNoDialogW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putSmartCardNoDialogW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_smartCardPinW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_smartCardPinW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putSmartCardPinW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putSmartCardPinW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectAlternativeNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectAlternativeNameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectCW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectCNW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectCNW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectDNW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectDNW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectEW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectEW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectKeyIdW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectKeyIdW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectLW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectLW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectOW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectOW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectOUW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectOUW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_subjectSW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_subjectSW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getTrustedRootW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getTrustedRootW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_uncommonOptionsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_uncommonOptionsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putUncommonOptionsW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putUncommonOptionsW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_validFromStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_validFromStrW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_validToStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_validToStrW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkCertU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_CheckRevokedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_CheckRevokedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_CheckSmartCardPinW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_CheckSmartCardPinW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportCertDerW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportCertDerW(System.IntPtr pObj, System.IntPtr pRetVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportCertDerBdW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportCertDerBdW(System.IntPtr pObj, System.IntPtr cerData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportCertDerFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportCertDerFileW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_exportCertPemW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_exportCertPemW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportCertPemFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportCertPemFileW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_exportCertXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_exportCertXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_ExportPrivateKeyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportPublicKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_ExportPublicKeyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportToPfxBdW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportToPfxBdW(System.IntPtr pObj, string password, int includeCertChain, System.IntPtr pfxData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportToPfxDataW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportToPfxDataW(System.IntPtr pObj, string password, int includeCertChain, System.IntPtr pRetVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_ExportToPfxFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_ExportToPfxFileW(System.IntPtr pObj, string pfxFilename, string pfxPassword, int bIncludeCertChain);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_FindIssuerW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_FindIssuerW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_GetCertChainW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_GetCertChainW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getEncodedW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getEncodedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getExtensionAsTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getExtensionAsTextW(System.IntPtr pObj, string oid);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getExtensionAsXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getExtensionAsXmlW(System.IntPtr pObj, string oid);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getPrivateKeyPemW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getPrivateKeyPemW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSpkiFingerprintW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getSpkiFingerprintW(System.IntPtr pObj, string hashAlg, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_getSubjectPartW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_getSubjectPartW(System.IntPtr pObj, string partNameOrOid);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_GetValidFromDtW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_GetValidFromDtW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_GetValidToDtW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_GetValidToDtW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_hashOfW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_hashOfW(System.IntPtr pObj, string part, string hashAlg, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_HasPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_HasPrivateKeyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadByCommonNameW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadByCommonNameW(System.IntPtr pObj, string cn);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadByEmailAddressW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadByEmailAddressW(System.IntPtr pObj, string emailAddress);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadByIssuerAndSerialNumberW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadByIssuerAndSerialNumberW(System.IntPtr pObj, string issuerCN, string serialNumber);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadBySubjectOidW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadBySubjectOidW(System.IntPtr pObj, string oid, string value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadByThumbprintW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadByThumbprintW(System.IntPtr pObj, string thumbprint, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadFromBase64W", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadFromBase64W(System.IntPtr pObj, string encodedCert);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadFromBdW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadFromBdW(System.IntPtr pObj, System.IntPtr certBytes);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadFromBinaryW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadFromBinaryW(System.IntPtr pObj, System.IntPtr data);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadFromFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadFromFileW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadFromSmartcardW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadFromSmartcardW(System.IntPtr pObj, string csp);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadPemW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadPemW(System.IntPtr pObj, string strPem);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadPfxBdW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadPfxBdW(System.IntPtr pObj, System.IntPtr pfxData, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadPfxDataW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadPfxDataW(System.IntPtr pObj, System.IntPtr pfxData, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadPfxFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadPfxFileW(System.IntPtr pObj, string pfxPath, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_LoadTaskResultW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_LoadTaskResultW(System.IntPtr pObj, System.IntPtr task);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_PemFileToDerFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_PemFileToDerFileW(System.IntPtr pObj, string fromPath, string toPath);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_SaveToFileW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_SaveToFileW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_SetFromEncodedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_SetFromEncodedW(System.IntPtr pObj, string encodedCert);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_SetPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_SetPrivateKeyW(System.IntPtr pObj, System.IntPtr privKey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_SetPrivateKeyPemW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_SetPrivateKeyPemW(System.IntPtr pObj, string privKeyPem);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_UseCertVaultW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_UseCertVaultW(System.IntPtr pObj, System.IntPtr vault);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_VerifySignatureW", CharSet = CharSet.Unicode)]
        private static extern int CkCertU_VerifySignatureW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertU_x509PKIPathv1W", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertU_x509PKIPathv1W(System.IntPtr pObj);


		public Cert()
		{
			m_pObj = CkCertU_CreateW();
			m_needDisposal = true;
		}

		public Cert(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkCertU_DisposeW(p);
			}
		}

		~Cert()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Cert
	/// <summary>
	/// The authority key identifier of the certificate in base64 string format. This is
	/// only present if the certificate contains the extension OID 2.5.29.35.
	/// </summary>
	public string AuthorityKeyId
	{
		get
		{
			return ckFromUni(CkCertU_authorityKeyIdW(m_pObj));
		}
	}

	/// <summary>
	/// Applies only when running on a Microsoft Windows operating system. If true,
	/// then any method that returns a certificate will not try to also access the
	/// associated private key, assuming one exists. This is useful if the certificate
	/// was installed with high-security such that a private key access would trigger
	/// the Windows OS to display a security warning dialog. The default value of this
	/// property is false.
	/// </summary>
	public bool AvoidWindowsPkAccess
	{
		get
		{
			return (CkCertU_getAvoidWindowsPkAccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertU_putAvoidWindowsPkAccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The version of the certificate (1, 2, or 3). A value of 0 indicates an error --
	/// the most likely cause being that the certificate object is empty (i.e. was never
	/// loaded with a certificate). Note: This is not the version of the software, it is
	/// the version of the X.509 certificate object. The version of the Chilkat
	/// certificate software is indicated by the Version property.
	/// </summary>
	public int CertVersion
	{
		get
		{
			return CkCertU_getCertVersionW(m_pObj);
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) If the
	/// HasKeyContainer property is true, then the certificate is linked to a key
	/// container and this property contains the name of the associated CSP
	/// (cryptographic service provider). When a certificate is linked to a key
	/// container , the following properties will provide information about the key
	/// container and private key: CspName, KeyContainerName, MachineKeyset, and Silent.
	/// </summary>
	public string CspName
	{
		get
		{
			return ckFromUni(CkCertU_cspNameW(m_pObj));
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkCertU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkCertU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Has a value of true if the certificate or any certificate in the chain of
	/// authority has expired. (This information is not available when running on
	/// Windows 95/98 computers.)
	/// </summary>
	public bool Expired
	{
		get
		{
			return (CkCertU_getExpiredW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// Returns a string containing a comma separated list of keywords with the extended
	/// key usages of the certificate. The list of possible extended key usages are:
	///     serverAuth - TLS WWW server authentication
	///     clientAuth - TLS WWW client authentication
	///     codeSigning - Signing of downloadable executable code
	///     emailProtection - Email protection
	///     timeStamping - Binding the hash of an object to a time
	///     OCSPSigning - Signing OCSP responses
	///
	/// </summary>
	public string ExtendedKeyUsage
	{
		get
		{
			return ckFromUni(CkCertU_extendedKeyUsageW(m_pObj));
		}
	}

	/// <summary>
	/// true if this certificate can be used for client authentication, otherwise
	/// false.
	/// </summary>
	public bool ForClientAuthentication
	{
		get
		{
			return (CkCertU_getForClientAuthenticationW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if this certificate can be used for code signing, otherwise false.
	/// </summary>
	public bool ForCodeSigning
	{
		get
		{
			return (CkCertU_getForCodeSigningW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if this certificate can be used for sending secure email, otherwise
	/// false.
	/// </summary>
	public bool ForSecureEmail
	{
		get
		{
			return (CkCertU_getForSecureEmailW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if this certificate can be used for server authentication, otherwise
	/// false.
	/// </summary>
	public bool ForServerAuthentication
	{
		get
		{
			return (CkCertU_getForServerAuthenticationW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if this certificate can be used for time stamping, otherwise false.
	/// </summary>
	public bool ForTimeStamping
	{
		get
		{
			return (CkCertU_getForTimeStampingW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Indicates
	/// whether this certificate is linked to a key container. If true then the
	/// certificate is linked to a key container (usually containing a private key). If
	/// false, then it is not.
	/// 
	/// When a certificate is linked to a key container , the following properties will
	/// provide information about the key container and private key: CspName,
	/// KeyContainerName, MachineKeyset, and Silent.
	/// </summary>
	public bool HasKeyContainer
	{
		get
		{
			return (CkCertU_getHasKeyContainerW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// Bitflags indicating the intended usages of the certificate. The flags are:
	/// Digital Signature: 0x80
	/// Non-Repudiation: 0x40
	/// Key Encipherment: 0x20
	/// Data Encipherment: 0x10
	/// Key Agreement: 0x08
	/// Certificate Signing: 0x04
	/// CRL Signing: 0x02
	/// Encipher-Only: 0x01
	///
	/// </summary>
	public uint IntendedKeyUsage
	{
		get
		{
			return CkCertU_getIntendedKeyUsageW(m_pObj);
		}
	}

	/// <summary>
	/// true if this is the root certificate, otherwise false.
	/// </summary>
	public bool IsRoot
	{
		get
		{
			return (CkCertU_getIsRootW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// The certificate issuer's country.
	/// </summary>
	public string IssuerC
	{
		get
		{
			return ckFromUni(CkCertU_issuerCW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's common name.
	/// </summary>
	public string IssuerCN
	{
		get
		{
			return ckFromUni(CkCertU_issuerCNW(m_pObj));
		}
	}

	/// <summary>
	/// The issuer's full distinguished name.
	/// </summary>
	public string IssuerDN
	{
		get
		{
			return ckFromUni(CkCertU_issuerDNW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's email address.
	/// </summary>
	public string IssuerE
	{
		get
		{
			return ckFromUni(CkCertU_issuerEW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's locality, which could be a city, count, township, or
	/// other geographic region.
	/// </summary>
	public string IssuerL
	{
		get
		{
			return ckFromUni(CkCertU_issuerLW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's organization, which is typically the company name.
	/// </summary>
	public string IssuerO
	{
		get
		{
			return ckFromUni(CkCertU_issuerOW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's organizational unit, which is the unit within the
	/// organization.
	/// </summary>
	public string IssuerOU
	{
		get
		{
			return ckFromUni(CkCertU_issuerOUW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate issuer's state or province.
	/// </summary>
	public string IssuerS
	{
		get
		{
			return ckFromUni(CkCertU_issuerSW(m_pObj));
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) If the
	/// HasKeyContainer property is true, then the certificate is linked to a key
	/// container and this property contains the name of the key container.
	/// 
	/// When a certificate is linked to a key container , the following properties will
	/// provide information about the key container and private key: CspName,
	/// KeyContainerName, MachineKeyset, and Silent.
	/// </summary>
	public string KeyContainerName
	{
		get
		{
			return ckFromUni(CkCertU_keyContainerNameW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkCertU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkCertU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkCertU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkCertU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) If the
	/// HasKeyContainer property is true, then the certificate is linked to a key
	/// container and this property indicates whether the key container is in the
	/// machine's keyset or in the keyset specific to the logged on user's account. If
	/// true, the key container is within the machine keyset. If false, it's in the
	/// user's keyset.
	/// 
	/// When a certificate is linked to a key container , the following properties will
	/// provide information about the key container and private key: CspName,
	/// KeyContainerName, MachineKeyset, and Silent.
	/// </summary>
	public bool MachineKeyset
	{
		get
		{
			return (CkCertU_getMachineKeysetW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// If present in the certificate's extensions, returns the OCSP URL of the
	/// certificate. (The Online Certificate Status Protocol (OCSP) is an Internet
	/// protocol used for obtaining the revocation status of an X.509 digital
	/// certificate.)
	/// </summary>
	public string OcspUrl
	{
		get
		{
			return ckFromUni(CkCertU_ocspUrlW(m_pObj));
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Indicates
	/// whether the private key was installed with security settings that allow it to be
	/// re-exported.
	/// </summary>
	public bool PrivateKeyExportable
	{
		get
		{
			return (CkCertU_getPrivateKeyExportableW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if the certificate or any certificate in the chain of authority has been
	/// revoked. This information is not available when running on Windows 95/98
	/// computers. Note: If this property is false, it could mean that it was not able
	/// to check the revocation status. Because of this uncertainty, a CheckRevoked
	/// method has been added. It returns an integer indicating one of three possible
	/// states: 1 (revoked) , 0 (not revoked), -1 (unable to check revocation status).
	/// </summary>
	public bool Revoked
	{
		get
		{
			return (CkCertU_getRevokedW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// The RFC822 name of the certificate. (The RFC822 name is one part of the Subject
	/// Alternative Name extension of a certificate, if it exists. It is often the only
	/// part of the SAN.)
	/// 
	/// If the certificate contains a list of RFC822 names then this property will
	/// return the comma separated list of names.
	/// 
	/// Starting in Chilkat v9.5.0.85, to get the complete Subject Alternative Name
	/// extension as XML, use the SubjectAlternativeName property.
	/// 
	///
	/// </summary>
	public string Rfc822Name
	{
		get
		{
			return ckFromUni(CkCertU_rfc822NameW(m_pObj));
		}
	}

	/// <summary>
	/// true if this is a self-signed certificate, otherwise false.
	/// </summary>
	public bool SelfSigned
	{
		get
		{
			return (CkCertU_getSelfSignedW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// The certificate's serial number as a decimal string.
	/// </summary>
	public string SerialDecimal
	{
		get
		{
			return ckFromUni(CkCertU_serialDecimalW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate's serial number as a hexidecimal string.
	/// </summary>
	public string SerialNumber
	{
		get
		{
			return ckFromUni(CkCertU_serialNumberW(m_pObj));
		}
	}

	/// <summary>
	/// Hexidecimal string of the SHA-1 thumbprint for the certificate. (This is the
	/// SHA1 hash of the binary DER representation of the entire X.509 certificate.)
	/// </summary>
	public string Sha1Thumbprint
	{
		get
		{
			return ckFromUni(CkCertU_sha1ThumbprintW(m_pObj));
		}
	}

	/// <summary>
	/// Returns true if the certificate and all certificates in the chain of authority
	/// have valid signatures, otherwise returns false.
	/// </summary>
	public bool SignatureVerified
	{
		get
		{
			return (CkCertU_getSignatureVerifiedW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.)
	/// 
	/// If the HasKeyContainer property is true, then the certificate is linked to a
	/// key container and this property indicates that the key container will attempt to
	/// open any keys silently without any user interface prompts.
	/// 
	/// When a certificate is linked to a key container , the following properties will
	/// provide information about the key container and private key: CspName,
	/// KeyContainerName, MachineKeyset, and Silent.
	/// 
	///
	/// </summary>
	public bool Silent
	{
		get
		{
			return (CkCertU_getSilentW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// If set to true, then no dialog will automatically popup if the SmartCardPin is
	/// incorrect. Instead, the method requiring the private key on the smart card will
	/// fail. The default value of this property is false, which means that if the
	/// SmartCardPin property is incorrect, a dialog with prompt will be displayed.
	/// </summary>
	public bool SmartCardNoDialog
	{
		get
		{
			return (CkCertU_getSmartCardNoDialogW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertU_putSmartCardNoDialogW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Can be set to the PIN value for a certificate / private key stored on a smart
	/// card.
	/// </summary>
	public string SmartCardPin
	{
		get
		{
			return ckFromUni(CkCertU_smartCardPinW(m_pObj));
		}
		set
		{
			CkCertU_putSmartCardPinW(m_pObj, value);
		}
	}

	/// <summary>
	/// The subject alternative name (SAN) name of the certificate returned as XML. See
	/// the examples linked below.
	/// </summary>
	public string SubjectAlternativeName
	{
		get
		{
			return ckFromUni(CkCertU_subjectAlternativeNameW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's country.
	/// </summary>
	public string SubjectC
	{
		get
		{
			return ckFromUni(CkCertU_subjectCW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's common name.
	/// </summary>
	public string SubjectCN
	{
		get
		{
			return ckFromUni(CkCertU_subjectCNW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's full distinguished name.
	/// </summary>
	public string SubjectDN
	{
		get
		{
			return ckFromUni(CkCertU_subjectDNW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's email address.
	/// </summary>
	public string SubjectE
	{
		get
		{
			return ckFromUni(CkCertU_subjectEW(m_pObj));
		}
	}

	/// <summary>
	/// The subject key identifier of the certificate in base64 string format. This is
	/// only present if the certificate contains the extension OID 2.5.29.14.
	/// </summary>
	public string SubjectKeyId
	{
		get
		{
			return ckFromUni(CkCertU_subjectKeyIdW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's locality, which could be a city, count, township, or
	/// other geographic region.
	/// </summary>
	public string SubjectL
	{
		get
		{
			return ckFromUni(CkCertU_subjectLW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's organization, which is typically the company name.
	/// </summary>
	public string SubjectO
	{
		get
		{
			return ckFromUni(CkCertU_subjectOW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's organizational unit, which is the unit within the
	/// organization.
	/// </summary>
	public string SubjectOU
	{
		get
		{
			return ckFromUni(CkCertU_subjectOUW(m_pObj));
		}
	}

	/// <summary>
	/// The certificate subject's state or province.
	/// </summary>
	public string SubjectS
	{
		get
		{
			return ckFromUni(CkCertU_subjectSW(m_pObj));
		}
	}

	/// <summary>
	/// Returns true if the certificate has a trusted root authority, otherwise
	/// returns false.
	/// 
	/// Note: As of version 9.5.0.41, the notion of what your application deems as
	/// trusted becomes more specific. The TrustedRoots class/object was added in
	/// v9.5.0.0. Prior to this, a certificate was considered to be anchored by a
	/// trusted root if the certificate chain could be established to a root
	/// (self-signed) certificate, AND if the root certificate was located somewhere in
	/// the Windows registry-based certificate stores. There are two problems with this:
	/// (1) it's a Windows-only solution. This property would always return false on
	/// non-Windows systems, and (2) it might be considered not a strong enough set of
	/// conditions for trusting a root certificate.
	/// 
	/// As of version 9.5.0.41, this property pays attention to the new TrustedRoots
	/// class/object, which allows for an application to specificallly indicate which
	/// root certificates are to be trusted. Certificates may be added to the
	/// TrustedRoots object via the LoadCaCertsPem or AddCert methods, and then
	/// activated by calling the TrustedRoots.Activate method. The activated trusted
	/// roots are deemed to be trusted in any Chilkat API method/property that needs to
	/// make this determination. In addition, the TrustedRoots object has a property
	/// named TrustSystemCaRoots, which defaults to true, which allows for backward
	/// compatibility. It will trust CA certificates stored in the Windows
	/// registry-based certificate stores, or if on Linux, will trust certificates found
	/// in /etc/ssl/certs/ca-certificates.crt.
	/// 
	///
	/// </summary>
	public bool TrustedRoot
	{
		get
		{
			return (CkCertU_getTrustedRootW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// This is a catch-all property to be used for uncommon needs. This property
	/// defaults to the empty string, and should typically remain empty.
	/// </summary>
	public string UncommonOptions
	{
		get
		{
			return ckFromUni(CkCertU_uncommonOptionsW(m_pObj));
		}
		set
		{
			CkCertU_putUncommonOptionsW(m_pObj, value);
		}
	}

	/// <summary>
	/// The date (in RFC822 string format) that this certificate becomes (or became)
	/// valid. It is a GMT/UTC date that is returned.
	/// </summary>
	public string ValidFromStr
	{
		get
		{
			return ckFromUni(CkCertU_validFromStrW(m_pObj));
		}
	}

	/// <summary>
	/// The date (in RFC822 string format) that this certificate becomes (or became)
	/// invalid. It is a GMT/UTC date that is returned.
	/// </summary>
	public string ValidToStr
	{
		get
		{
			return ckFromUni(CkCertU_validToStrW(m_pObj));
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkCertU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkCertU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Returns 1 if the certificate has been revoked, 0 if not revoked, and -1 if
	/// unable to check the revocation status.
	/// 
	/// Note: This method is only implemented on Windows systems. It uses the underlying
	/// Microsoft CertVerifyRevocation Platform SDK function to check the revocation
	/// status of a certificate. (Search "CertVerifyRevocation" to get information about
	/// it.)
	/// 
	/// Non-Windows (and Windows) applications can send an OCSP request as shown in the
	/// example below.
	/// 
	///
	/// </summary>
	public int CheckRevoked()
	{
		int result = CkCertU_CheckRevokedW(m_pObj);
		return result;
	}
	/// <summary>
	/// Verifies that the SmartCardPin property setting is correct. Returns 1 if
	/// correct, 0 if incorrect, and -1 if unable to check because the underlying CSP
	/// does not support the functionality.
	/// </summary>
	public int CheckSmartCardPin()
	{
		int result = CkCertU_CheckSmartCardPinW(m_pObj);
		return result;
	}
	/// <summary>
	/// Exports the digital certificate to ASN.1 DER format.
	/// </summary>
	public byte[] ExportCertDer()
	{
		System.IntPtr hResultData = newCkByteData();
		CkCertU_ExportCertDerW(m_pObj, hResultData);
		byte[] retBytes = ckToBytes(hResultData);
		disposeCkByteData(hResultData);
		return retBytes;
	}
	/// <summary>
	/// Exports the digital certificate in ASN.1 DER format to a BinData object.
	/// </summary>
	public bool ExportCertDerBd(BinData cerData)
	{
		int result = CkCertU_ExportCertDerBdW(m_pObj, cerData == null ? System.IntPtr.Zero : cerData.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Exports the digital certificate to ASN.1 DER format binary file.
	/// </summary>
	public bool ExportCertDerFile(string path)
	{
		int result = CkCertU_ExportCertDerFileW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Exports the digital certificate to an unencrypted PEM formatted string.
	/// </summary>
	public string ExportCertPem()
	{
		System.IntPtr result = CkCertU_exportCertPemW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Exports the digital certificate to an unencrypted PEM formatted file.
	/// </summary>
	public bool ExportCertPemFile(string path)
	{
		int result = CkCertU_ExportCertPemFileW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Exports a certificate to an XML format where the XML tags are the names of the
	/// ASN.1 objects that compose the X.509 certificate. Binary data is either hex or
	/// base64 encoded. (The binary data for a "bits" ASN.1 tag is hex encoded, whereas
	/// for all other ASN.1 tags, such as "octets", it is base64.)
	/// </summary>
	public string ExportCertXml()
	{
		System.IntPtr result = CkCertU_exportCertXmlW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Exports the certificate's private key.
	/// </summary>
	public PrivateKey ExportPrivateKey()
	{
		System.IntPtr result = CkCertU_ExportPrivateKeyW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// Exports the certificate's public key.
	/// </summary>
	public PublicKey ExportPublicKey()
	{
		System.IntPtr result = CkCertU_ExportPublicKeyW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new PublicKey(result);
	}
	/// <summary>
	/// Exports the certificate and private key (if available) to pfxData. The password is what
	/// will be required to access the PFX contents at a later time. If includeCertChain is true,
	/// then the certificates in the chain of authority are also included in the PFX.
	/// </summary>
	public bool ExportToPfxBd(string password, bool includeCertChain, BinData pfxData)
	{
		int result = CkCertU_ExportToPfxBdW(m_pObj, password, includeCertChain == false ? 0 : 1, pfxData == null ? System.IntPtr.Zero : pfxData.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Exports the certificate and private key (if available) to an in-memory PFX
	/// image. The password is what will be required to access the PFX contents at a later
	/// time. If includeCertChain is true, then the certificates in the chain of authority are
	/// also included in the PFX.
	/// </summary>
	public byte[] ExportToPfxData(string password, bool includeCertChain)
	{
		System.IntPtr hResultData = newCkByteData();
		CkCertU_ExportToPfxDataW(m_pObj, password, includeCertChain == false ? 0 : 1, hResultData);
		byte[] retBytes = ckToBytes(hResultData);
		disposeCkByteData(hResultData);
		return retBytes;
	}
	/// <summary>
	/// Exports the certificate and private key (if available) to a PFX (.pfx or .p12)
	/// file. The output PFX is secured using the pfxPassword. If bIncludeCertChain is true, then the
	/// certificates in the chain of authority are also included in the PFX output file.
	/// </summary>
	public bool ExportToPfxFile(string pfxFilename, string pfxPassword, bool bIncludeCertChain)
	{
		int result = CkCertU_ExportToPfxFileW(m_pObj, pfxFilename, pfxPassword, bIncludeCertChain == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Finds and returns the issuer certificate. If the certificate is a root or
	/// self-issued, then the certificate returned is a copy of the caller certificate.
	/// (The IsRoot property can be check to see if the certificate is a root (or
	/// self-issued) certificate.)
	/// </summary>
	public Cert FindIssuer()
	{
		System.IntPtr result = CkCertU_FindIssuerW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new Cert(result);
	}
	/// <summary>
	/// Returns a certficate chain object containing all the certificates (including
	/// this one), in the chain of authentication to the trusted root (if possible). If
	/// this certificate object was loaded from a PFX, then the certiicates contained in
	/// the PFX are automatically available for building the certificate chain. The
	/// UseCertVault method can be called to provide additional certificates that might
	/// be required to build the cert chain. Finally, the TrustedRoots object can be
	/// used to provide a way of making trusted root certificates available.
	/// 
	/// Note: Prior to v9.5.0.50, this method would fail if the certificate chain could
	/// not be completed to the root. Starting in v9.5.0.50, the incomplete certificate
	/// chain will be returned. The certificate chain's ReachesRoot property can be
	/// examined to see if the chain was completed to the root.
	/// 
	/// On Windows systems, the registry-based certificate stores are automatically
	/// consulted if needed to locate intermediate or root certificates in the chain.
	/// Chilkat searches certificate stores in the following order. SeeSystem Store
	/// Locations
	/// &lt;https://docs.microsoft.com/en-us/windows/desktop/seccrypto/system-store-location
	/// s&gt; for more information.
	///     Current-User "CA" Certificate Store
	///     Local-Machine "CA" Certificate Store
	///     Current-User "Root" Certificate Store
	///     Local-Machine "Root" Certificate Store
	///     Current-User "MY" Certificate Store
	///     Local-Machine "MY" Certificate Store
	///     Current-User "ADDRESSBOOK" Certificate Store (if it exists)
	///     Local-Machine "ADDRESSBOOK" Certificate Store (if it exists)
	/// 
	///
	/// </summary>
	public CertChain GetCertChain()
	{
		System.IntPtr result = CkCertU_GetCertChainW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertChain(result);
	}
	/// <summary>
	/// Returns a base64 encoded string representation of the certificate's binary DER
	/// format, which can be passed to SetFromEncoded to recreate the certificate
	/// object.
	/// </summary>
	public string GetEncoded()
	{
		System.IntPtr result = CkCertU_getEncodedW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the certificate extension data as a string. This method should only be
	/// called for those extensions with text values NOT stored as binary ASN.1. In most
	/// cases, applications should call GetExtensionAsXml because most extensions
	/// contain ASN.1 values that need to be decoded..
	/// </summary>
	public string GetExtensionAsText(string oid)
	{
		System.IntPtr result = CkCertU_getExtensionAsTextW(m_pObj, oid);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the certificate extension data in XML format (converted from ASN.1). The
	/// oid is an OID, such as the ones listed here:
	/// http://www.alvestrand.no/objectid/2.5.29.html
	/// 
	/// Note: In many cases, the data within the XML is returned base64 encoded. An
	/// application may need to take one further step to base64 decode the information
	/// contained within the XML.
	/// 
	///
	/// </summary>
	public string GetExtensionAsXml(string oid)
	{
		System.IntPtr result = CkCertU_getExtensionAsXmlW(m_pObj, oid);
		return ckFromUni(result);
	}
	/// <summary>
	/// Exports the certificate's private key to a PEM string (if the private key is
	/// available).
	/// </summary>
	public string GetPrivateKeyPem()
	{
		System.IntPtr result = CkCertU_getPrivateKeyPemW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the SPKI Fingerprint suitable for use in pinning. (See RFC 7469.) An
	/// SPKI Fingerprint is defined as the output of a known cryptographic hash
	/// algorithm whose input is the DER-encoded ASN.1 representation of the Subject
	/// Public Key Info (SPKI) of an X.509 certificate. The hashAlg specifies the hash
	/// algorithm and may be "sha256", "sha384", "sha512", "sha1", "md2", "md5",
	/// "haval", "ripemd128", "ripemd160","ripemd256", or "ripemd320". The encoding
	/// specifies the encoding, and may be "base64", "hex", or any of the encoding modes
	/// specified in the article at the link below.
	/// </summary>
	public string GetSpkiFingerprint(string hashAlg, string encoding)
	{
		System.IntPtr result = CkCertU_getSpkiFingerprintW(m_pObj, hashAlg, encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns a part of the certificate's subject by name or OID. The partNameOrOid can be a
	/// part name, such as "CN", "O", "OU", "E", "S", "L", "C", or "SERIALNUMBER", or it
	/// can be an OID such as "2.5.4.3".
	/// </summary>
	public string GetSubjectPart(string partNameOrOid)
	{
		System.IntPtr result = CkCertU_getSubjectPartW(m_pObj, partNameOrOid);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the date/time this certificate becomes (or became) valid.
	/// </summary>
	public CkDateTime GetValidFromDt()
	{
		System.IntPtr result = CkCertU_GetValidFromDtW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CkDateTime(result);
	}
	/// <summary>
	/// Returns the date/time this certificate becomes (or became) invalid.
	/// </summary>
	public CkDateTime GetValidToDt()
	{
		System.IntPtr result = CkCertU_GetValidToDtW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CkDateTime(result);
	}
	/// <summary>
	/// Returns an encoded hash of a particular part of the certificate. The part may be
	/// one of the following:
	///     IssuerDN
	///     IssuerPublicKey
	///     SubjectDN
	///     SubjectPublicKey
	/// 
	/// The hashAlg is the name of the hash algorithm, such as "sha1", "sha256", "sha384",
	/// "sha512", "md5", etc. The encoding is the format to return, such as "hex", "base64",
	/// etc.
	/// 
	///
	/// </summary>
	public string HashOf(string part, string hashAlg, string encoding)
	{
		System.IntPtr result = CkCertU_hashOfW(m_pObj, part, hashAlg, encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns true if a private key associated with the certificate is available.
	/// </summary>
	public bool HasPrivateKey()
	{
		int result = CkCertU_HasPrivateKeyW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Searches
	/// the Windows Local Machine and Current User registry-based certificate stores for
	/// a certificate having the common name specified. If found, the certificate is
	/// loaded and ready for use.
	/// </summary>
	public bool LoadByCommonName(string cn)
	{
		int result = CkCertU_LoadByCommonNameW(m_pObj, cn);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Searches
	/// the Windows Local Machine and Current User registry-based certificate stores for
	/// a certificate containing the email address specified. If found, the certificate
	/// is loaded and ready for use.
	/// </summary>
	public bool LoadByEmailAddress(string emailAddress)
	{
		int result = CkCertU_LoadByEmailAddressW(m_pObj, emailAddress);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Searches
	/// the Windows Local Machine and Current User registry-based certificate stores for
	/// a certificate matching the issuerCN and having an issuer matching the serialNumber. If
	/// found, the certificate is loaded and ready for use.
	/// 
	/// Note: The hex serial number should be uppercase. Starting in Chilkat v9.5.0.88,
	/// the hex serial number is case-insensitive.
	/// 
	///
	/// </summary>
	public bool LoadByIssuerAndSerialNumber(string issuerCN, string serialNumber)
	{
		int result = CkCertU_LoadByIssuerAndSerialNumberW(m_pObj, issuerCN, serialNumber);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Searches
	/// the Windows Local Machine and Current User registry-based certificate stores for
	/// a certificate containing a subject part matching the oid and value.
	/// </summary>
	public bool LoadBySubjectOid(string oid, string value)
	{
		int result = CkCertU_LoadBySubjectOidW(m_pObj, oid, value);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// (Relevant only when running on a Microsoft Windows operating system.) Searches
	/// the Windows Local Machine and Current User registry-based certificate stores for
	/// a certificate having an MD5 or SHA1 thumbprint equal to the thumbprint. The hash (i.e.
	/// thumbprint) is passed as a string using the encoding specified by encoding (such as
	/// "base64", "hex", etc.).
	/// </summary>
	public bool LoadByThumbprint(string thumbprint, string encoding)
	{
		int result = CkCertU_LoadByThumbprintW(m_pObj, thumbprint, encoding);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads an ASN.1 or DER encoded certificate represented in a Base64 string.
	/// </summary>
	public bool LoadFromBase64(string encodedCert)
	{
		int result = CkCertU_LoadFromBase64W(m_pObj, encodedCert);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads an X.509 certificate from data contained in certBytes.
	/// 
	/// Note: The certBytes may contain the certificate in any format. It can be binary DER
	/// (ASN.1), PEM, Base64, etc. Chilkat will automatically detect the format.
	/// 
	///
	/// </summary>
	public bool LoadFromBd(BinData certBytes)
	{
		int result = CkCertU_LoadFromBdW(m_pObj, certBytes == null ? System.IntPtr.Zero : certBytes.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads an X.509 certificate from ASN.1 DER encoded bytes.
	/// 
	/// Note: The data may contain the certificate in any format. It can be binary DER
	/// (ASN.1), PEM, Base64, etc. Chilkat will automatically detect the format.
	/// 
	///
	/// </summary>
	public bool LoadFromBinary(byte[] data)
	{
		System.IntPtr hInData0 = newCkByteData();
		System.IntPtr pInBytes0 = ckFromBytes(data,hInData0);
		int result = CkCertU_LoadFromBinaryW(m_pObj, hInData0);
		if (pInBytes0 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes0);
		disposeCkByteData(hInData0);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a certificate from a .cer, .crt, .p7b, or .pem file. This method accepts
	/// certificates from files in any of the following formats:
	/// 1. DER encoded binary X.509 (.CER)
	/// 2. Base-64 encoded X.509 (.CER)
	/// 3. Cryptographic Message Syntax Standard - PKCS #7 Certificates (.P7B)
	/// 4. PEM format
	/// This method decodes the certificate based on the contents if finds within the
	/// file, and not based on the file extension. If your certificate is in a file
	/// having a different extension, try loading it using this method before assuming
	/// it won't work. This method does not load .p12 or .pfx (PKCS #12) files.
	/// </summary>
	public bool LoadFromFile(string path)
	{
		int result = CkCertU_LoadFromFileW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Starting in Chilkat v9.5.0.87, the csp can be a string that specifies the
	/// certificate to be loaded by either Subject Common Name (CN) or hex serial
	/// number. For example, instead of passing a CSP name, your application would pass
	/// a string such as "CN=The cert subject common name" or "serial=01020304". See the
	/// linked examples below. If a certificate is specified by CN or Serial, then each
	/// connected smartcard and USB token is searched for the matching certificate. If
	/// the certificate is found, it is loaded and this method returns true.
	/// 
	/// Otherwise, this method loads the X.509 certificate from the smartcard currently
	/// in the reader, or from a USB token.
	/// 
	/// If the smartcard contains multiple certificates, this method arbitrarily picks
	/// one.
	/// 
	/// If the csp does not begin with "CN=" or "serial=", then the csp can be set to
	/// the name of the CSP (Cryptographic Service Provider) that should be used. If
	/// csp is an empty string, then the 1st CSP found matching one of the following
	/// names will be used:
	/// 
	///     Microsoft Smart Card Key Storage Provider
	///     Microsoft Base Smart Card Crypto Provider
	///     Bit4id Universal Middleware Provider
	///     YubiHSM Key Storage Provider (starting in v9.5.0.83)
	///     eToken Base Cryptographic Provider
	///     FTSafe ePass1000 RSA Cryptographic Service Provider
	///     SecureStoreCSP
	///     EnterSafe ePass2003 CSP v2.0
	///     Gemalto Classic Card CSP
	///     PROXKey CSP India V1.0
	///     PROXKey CSP India V2.0
	///     TRUST KEY CSP V1.0
	///     Watchdata Brazil CSP V1.0
	///     Luna Cryptographic Services for Microsoft Windows
	///     Luna SChannel Cryptographic Services for Microsoft Windows
	///     Safenet RSA Full Cryptographic Provider
	///     nCipher Enhanced Cryptographic Provider
	///     SafeSign Standard Cryptographic Service Provider
	///     SafeSign Standard RSA and AES Cryptographic Service Provider
	///     MySmartLogon NFC CSP
	///     NFC Connector Enterprise
	///     ActivClient Cryptographic Service Provider
	///     EnterSafe ePass2003 CSP v1.0
	///     Oberthur Card Systems Cryptographic Provider
	///     Athena ASECard Crypto CSP"
	///
	/// </summary>
	public bool LoadFromSmartcard(string csp)
	{
		int result = CkCertU_LoadFromSmartcardW(m_pObj, csp);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the certificate from a PEM string.
	/// </summary>
	public bool LoadPem(string strPem)
	{
		int result = CkCertU_LoadPemW(m_pObj, strPem);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the certificate from the PFX contained in pfxData. Note: If the PFX contains
	/// multiple certificates, the 1st certificate in the PFX is loaded.
	/// </summary>
	public bool LoadPfxBd(BinData pfxData, string password)
	{
		int result = CkCertU_LoadPfxBdW(m_pObj, pfxData == null ? System.IntPtr.Zero : pfxData.getImpl(), password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a PFX from an in-memory image of a PFX file. Note: If the PFX contains
	/// multiple certificates, the 1st certificate in the PFX is loaded.
	/// </summary>
	public bool LoadPfxData(byte[] pfxData, string password)
	{
		System.IntPtr hInData0 = newCkByteData();
		System.IntPtr pInBytes0 = ckFromBytes(pfxData,hInData0);
		int result = CkCertU_LoadPfxDataW(m_pObj, hInData0, password);
		if (pInBytes0 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes0);
		disposeCkByteData(hInData0);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a PFX file. Note: If the PFX contains multiple certificates, the 1st
	/// certificate in the PFX is loaded.
	/// </summary>
	public bool LoadPfxFile(string pfxPath, string password)
	{
		int result = CkCertU_LoadPfxFileW(m_pObj, pfxPath, password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the certificate from a completed asynchronous task.
	/// </summary>
	public bool LoadTaskResult(Task task)
	{
		int result = CkCertU_LoadTaskResultW(m_pObj, task == null ? System.IntPtr.Zero : task.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Converts a PEM file to a DER file.
	/// </summary>
	public bool PemFileToDerFile(string fromPath, string toPath)
	{
		int result = CkCertU_PemFileToDerFileW(m_pObj, fromPath, toPath);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkCertU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves a certificate object to a .cer file.
	/// </summary>
	public bool SaveToFile(string path)
	{
		int result = CkCertU_SaveToFileW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Initializes the certificate object from a base64 encoded string representation
	/// of the certificate's binary DER format.
	/// </summary>
	public bool SetFromEncoded(string encodedCert)
	{
		int result = CkCertU_SetFromEncodedW(m_pObj, encodedCert);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Used to associate a private key with the certificate for subsequent (PKCS7)
	/// signature creation or decryption.
	/// </summary>
	public bool SetPrivateKey(PrivateKey privKey)
	{
		int result = CkCertU_SetPrivateKeyW(m_pObj, privKey == null ? System.IntPtr.Zero : privKey.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Same as SetPrivateKey, but the key is provided in unencrypted PEM format. (Note:
	/// The privKeyPem is not a file path, it is the actual PEM text.)
	/// </summary>
	public bool SetPrivateKeyPem(string privKeyPem)
	{
		int result = CkCertU_SetPrivateKeyPemW(m_pObj, privKeyPem);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds an XML certificate vault to the object's internal list of sources to be
	/// searched for certificates for help in building certificate chains and verifying
	/// the certificate signature to the trusted root.
	/// </summary>
	public bool UseCertVault(XmlCertVault vault)
	{
		int result = CkCertU_UseCertVaultW(m_pObj, vault == null ? System.IntPtr.Zero : vault.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies the certificate signature, as well as the signatures of all
	/// certificates in the chain of authentication to the trusted root. Returns true
	/// if all signatures are verified to the trusted root. Otherwise returns false.
	/// </summary>
	public bool VerifySignature()
	{
		int result = CkCertU_VerifySignatureW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the base64 representation of an X509PKIPathv1 containing just the
	/// calling certificate. This is typically used in an X.509 Binary Security Token.
	/// It is a PKIPath that contains an ordered list of X.509 public certificates
	/// packaged in a PKIPath. The X509PKIPathv1 token type may be used to represent a
	/// certificate path. (This is sometimes used in XAdES signatures.)
	/// </summary>
	public string X509PKIPathv1()
	{
		System.IntPtr result = CkCertU_x509PKIPathv1W(m_pObj);
		return ckFromUni(result);
	}


	}
}

