// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Dh : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkDhU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkDhU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkDhU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_getGW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_getGW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkDhU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_pW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_pW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkDhU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_createEW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_createEW(System.IntPtr pObj, int numBits);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_findKW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkDhU_findKW(System.IntPtr pObj, string E);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_GenPGW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_GenPGW(System.IntPtr pObj, int numBits, int G);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_SetPGW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_SetPGW(System.IntPtr pObj, string p, int g);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_UnlockComponentW", CharSet = CharSet.Unicode)]
        private static extern int CkDhU_UnlockComponentW(System.IntPtr pObj, string unlockCode);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkDhU_UseKnownPrimeW", CharSet = CharSet.Unicode)]
        private static extern void CkDhU_UseKnownPrimeW(System.IntPtr pObj, int index);


		public Dh()
		{
			m_pObj = CkDhU_CreateW();
			m_needDisposal = true;
		}

		public Dh(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkDhU_DisposeW(p);
			}
		}

		~Dh()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Dh
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkDhU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkDhU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// The generator. The value of G should be either 2 or 5.
	/// </summary>
	public int G
	{
		get
		{
			return CkDhU_getGW(m_pObj);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkDhU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkDhU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkDhU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkDhU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkDhU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// A "safe" large prime returned as a hex string. The hex string represent a bignum
	/// in SSH1 format.
	/// </summary>
	public string P
	{
		get
		{
			return ckFromUni(CkDhU_pW(m_pObj));
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkDhU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkDhU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkDhU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// The 1st step in Diffie-Hellman key exchange (to generate a shared-secret). The
	/// numBits should be twice the size (in bits) of the shared secret to be generated.
	/// For example, if you are using DH to create a 128-bit AES session key, then numBits
	/// should be set to 256. Returns E as a bignum in SSH-format as a hex string.
	/// </summary>
	public string CreateE(int numBits)
	{
		System.IntPtr result = CkDhU_createEW(m_pObj, numBits);
		return ckFromUni(result);
	}
	/// <summary>
	/// The 2nd and final step in Diffie-Hellman (DH) key exchange. E is the E
	/// created by the other party. Returns the shared secret (K) as an SSH1-format
	/// bignum encoded as a hex string.
	/// </summary>
	public string FindK(string E)
	{
		System.IntPtr result = CkDhU_findKW(m_pObj, E);
		return ckFromUni(result);
	}
	/// <summary>
	/// Generates a large safe prime that is numBits bits in size using the generator G.
	/// Generating a new (random) P is expensive in both time and CPU cycles. A prime
	/// should be 1024 or more bits in length.
	/// </summary>
	public bool GenPG(int numBits, int G)
	{
		int result = CkDhU_GenPGW(m_pObj, numBits, G);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkDhU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets explicit values for P and G. Returns true if P and G conform to the
	/// requirements for Diffie-Hellman. P is an SSH1-format bignum passed as a
	/// hexidecimalized string.
	/// </summary>
	public bool SetPG(string p, int g)
	{
		int result = CkDhU_SetPGW(m_pObj, p, g);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Unlocks the component. This must be called once prior to calling any other
	/// method. A fully-functional 30-day trial is automatically started when an
	/// arbitrary string is passed to this method. For example, passing "Hello", or
	/// "abc123" will unlock the component for the 1st thirty days after the initial
	/// install.
	/// </summary>
	public bool UnlockComponent(string unlockCode)
	{
		int result = CkDhU_UnlockComponentW(m_pObj, unlockCode);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets P and G to a known safe prime. The index may have the following values:
	/// 
	/// 1: First Oakley Default Group from RFC2409, section 6.1. Generator is 2. The
	/// prime is: 2^768 - 2 ^704 - 1 + 2^64 * { [2^638 pi] + 149686 }
	/// 
	/// 2: Prime for 2nd Oakley Group (RFC 2409) -- 1024-bit MODP Group. Generator is 2.
	/// The prime is: 2^1024 - 2^960 - 1 + 2^64 * { [2^894 pi] + 129093 }.
	/// 
	/// 3: 1536-bit MODP Group from RFC3526, Section 2. Generator is 2. The prime is:
	/// 2^1536 - 2^1472 - 1 + 2^64 * { [2^1406 pi] + 741804 }
	/// 
	/// 4: Prime for 14th Oakley Group (RFC 3526) -- 2048-bit MODP Group. Generator is
	/// 2. The prime is: 2^2048 - 2^1984 - 1 + 2^64 * { [2^1918 pi] + 124476 }
	/// 
	/// 5: 3072-bit MODP Group from RFC3526, Section 4. Generator is 2. The prime is:
	/// 2^3072 - 2^3008 - 1 + 2^64 * { [2^2942 pi] + 1690314 }
	/// 
	/// 6: 4096-bit MODP Group from RFC3526, Section 5. Generator is 2. The prime is:
	/// 2^4096 - 2^4032 - 1 + 2^64 * { [2^3966 pi] + 240904 }
	/// 
	/// 7: 6144-bit MODP Group from RFC3526, Section 6. Generator is 2. The prime is:
	/// 2^6144 - 2^6080 - 1 + 2^64 * { [2^6014 pi] + 929484 }
	/// 
	/// 8: 8192-bit MODP Group from RFC3526, Section 7. Generator is 2. The prime is:
	/// 2^8192 - 2^8128 - 1 + 2^64 * { [2^8062 pi] + 4743158 }
	/// 
	///
	/// </summary>
	public void UseKnownPrime(int index)
	{
		CkDhU_UseKnownPrimeW(m_pObj, index);
		return;
	}


	}
}

