// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class EdDSA : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkEdDSAU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkEdDSAU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkEdDSAU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkEdDSAU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkEdDSAU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkEdDSAU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkEdDSAU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_GenEd25519KeyW", CharSet = CharSet.Unicode)]
        private static extern int CkEdDSAU_GenEd25519KeyW(System.IntPtr pObj, System.IntPtr prng, System.IntPtr privKey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkEdDSAU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_sharedSecretENCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_sharedSecretENCW(System.IntPtr pObj, System.IntPtr privkey, System.IntPtr pubkey, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_signBdENCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEdDSAU_signBdENCW(System.IntPtr pObj, System.IntPtr bd, string encoding, System.IntPtr privkey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEdDSAU_VerifyBdENCW", CharSet = CharSet.Unicode)]
        private static extern int CkEdDSAU_VerifyBdENCW(System.IntPtr pObj, System.IntPtr bd, string encodedSig, string enocding, System.IntPtr pubkey);


		public EdDSA()
		{
			m_pObj = CkEdDSAU_CreateW();
			m_needDisposal = true;
		}

		public EdDSA(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkEdDSAU_DisposeW(p);
			}
		}

		~EdDSA()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = EdDSA
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkEdDSAU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkEdDSAU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkEdDSAU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkEdDSAU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkEdDSAU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkEdDSAU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkEdDSAU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkEdDSAU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkEdDSAU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkEdDSAU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Generates an Ed25519 key. privKey is an output argument. The generated key is
	/// created in privKey.
	/// </summary>
	public bool GenEd25519Key(Prng prng, PrivateKey privKey)
	{
		int result = CkEdDSAU_GenEd25519KeyW(m_pObj, prng == null ? System.IntPtr.Zero : prng.getImpl(), privKey == null ? System.IntPtr.Zero : privKey.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkEdDSAU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Computes a shared secret given a private and public key. For example, Alice and
	/// Bob can compute the identical shared secret by doing the following: Alice sends
	/// Bob her public key, and Bob calls SharedSecretENC with his private key and
	/// Alice's public key. Bob sends Alice his public key, and Alice calls
	/// SharedSecretENC with her private key and Bob's public key. Both calls to
	/// SharedSecretENC will produce the same result. The resulting bytes are returned
	/// in encoded string form (hex, base64, etc) as specified by encoding.
	/// </summary>
	public string SharedSecretENC(PrivateKey privkey, PublicKey pubkey, string encoding)
	{
		System.IntPtr result = CkEdDSAU_sharedSecretENCW(m_pObj, privkey == null ? System.IntPtr.Zero : privkey.getImpl(), pubkey == null ? System.IntPtr.Zero : pubkey.getImpl(), encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Signs the contents of bd and returns the signature according to encoding. The
	/// encoding can be any encoding supported by Chilkat, such as "hex", "base64", etc.
	/// </summary>
	public string SignBdENC(BinData bd, string encoding, PrivateKey privkey)
	{
		System.IntPtr result = CkEdDSAU_signBdENCW(m_pObj, bd == null ? System.IntPtr.Zero : bd.getImpl(), encoding, privkey == null ? System.IntPtr.Zero : privkey.getImpl());
		return ckFromUni(result);
	}
	/// <summary>
	/// Verifies the signature against the contents of bd. The encodedSig is passed as an
	/// encoded string (such as hex, base64, etc.) using the encoding specified by enocding.
	/// The pubkey contains the Ed25519 public key used to verify.
	/// </summary>
	public bool VerifyBdENC(BinData bd, string encodedSig, string enocding, PublicKey pubkey)
	{
		int result = CkEdDSAU_VerifyBdENCW(m_pObj, bd == null ? System.IntPtr.Zero : bd.getImpl(), encodedSig, enocding, pubkey == null ? System.IntPtr.Zero : pubkey.getImpl());
		return result == 0 ? false : true;
	}


	}
}

