// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class HtmlToText : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkHtmlToTextU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkHtmlToTextU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_getDecodeHtmlEntitiesW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_getDecodeHtmlEntitiesW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putDecodeHtmlEntitiesW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putDecodeHtmlEntitiesW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_getRightMarginW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_getRightMarginW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putRightMarginW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putRightMarginW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_getSuppressLinksW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_getSuppressLinksW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putSuppressLinksW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putSuppressLinksW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkHtmlToTextU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_readFileToStringW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_readFileToStringW(System.IntPtr pObj, string filename, string srcCharset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_toTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHtmlToTextU_toTextW(System.IntPtr pObj, string html);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_UnlockComponentW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_UnlockComponentW(System.IntPtr pObj, string code);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHtmlToTextU_WriteStringToFileW", CharSet = CharSet.Unicode)]
        private static extern int CkHtmlToTextU_WriteStringToFileW(System.IntPtr pObj, string stringToWrite, string filename, string charset);


		public HtmlToText()
		{
			m_pObj = CkHtmlToTextU_CreateW();
			m_needDisposal = true;
		}

		public HtmlToText(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkHtmlToTextU_DisposeW(p);
			}
		}

		~HtmlToText()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = HtmlToText
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkHtmlToTextU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkHtmlToTextU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// If true, then HTML entities are automatically decoded. For example _AMP_amp;
	/// is automatically decoded to _AMP_. If this property is set to false, then HTML
	/// entities are not decoded. The default value is true.
	/// </summary>
	public bool DecodeHtmlEntities
	{
		get
		{
			return (CkHtmlToTextU_getDecodeHtmlEntitiesW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkHtmlToTextU_putDecodeHtmlEntitiesW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkHtmlToTextU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkHtmlToTextU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkHtmlToTextU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkHtmlToTextU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkHtmlToTextU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Used to control wrapping of text. The default value is 80. When the text gets
	/// close to this margin, the converter will try to break the line at a SPACE
	/// character. Set this property to 0 for no right margin.
	/// </summary>
	public int RightMargin
	{
		get
		{
			return CkHtmlToTextU_getRightMarginW(m_pObj);
		}
		set
		{
			CkHtmlToTextU_putRightMarginW(m_pObj, value);
		}
	}

	/// <summary>
	/// If false, then link URL's are preserved inline. For example, the following
	/// HTML fragment:
	/// 
	/// _LT_p&gt;Test _LT_a href="http://www.chilkatsoft.com/"&gt;chilkat_LT_/a&gt;_LT_/p&gt;
	/// 
	/// converts to:
	/// Test chilkat _LT_http://www.chilkatsoft.com/&gt;
	/// If this property is true, the above HTML would convert to:
	/// Test chilkat
	/// The default value of this property is true.
	/// 
	///
	/// </summary>
	public bool SuppressLinks
	{
		get
		{
			return (CkHtmlToTextU_getSuppressLinksW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkHtmlToTextU_putSuppressLinksW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkHtmlToTextU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkHtmlToTextU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkHtmlToTextU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Convenience method for reading a text file into a string. The character encoding
	/// of the text file is specified by srcCharset. Valid values, such as "iso-8895-1" or
	/// "utf-8" are listed at:List of Charsets
	/// &lt;http://blog.chilkatsoft.com/?p=463&gt;.
	/// </summary>
	public string ReadFileToString(string filename, string srcCharset)
	{
		System.IntPtr result = CkHtmlToTextU_readFileToStringW(m_pObj, filename, srcCharset);
		return ckFromUni(result);
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkHtmlToTextU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Converts HTML to plain-text.
	/// </summary>
	public string ToText(string html)
	{
		System.IntPtr result = CkHtmlToTextU_toTextW(m_pObj, html);
		return ckFromUni(result);
	}
	/// <summary>
	/// Unlocks the component. An arbitrary unlock code may be passed to automatically
	/// begin a 30-day trial.
	/// 
	/// This class is included with the Chilkat HTML-to-XML conversion component
	/// license.
	/// 
	///
	/// </summary>
	public bool UnlockComponent(string code)
	{
		int result = CkHtmlToTextU_UnlockComponentW(m_pObj, code);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Convenience method for saving a string to a file. The character encoding of the
	/// output text file is specified by charset (the string is converted to this charset
	/// when writing). Valid values, such as "iso-8895-1" or "utf-8" are listed at:List
	/// of Charsets
	/// &lt;http://blog.chilkatsoft.com/?p=463&gt;.
	/// </summary>
	public bool WriteStringToFile(string stringToWrite, string filename, string charset)
	{
		int result = CkHtmlToTextU_WriteStringToFileW(m_pObj, stringToWrite, filename, charset);
		return result == 0 ? false : true;
	}


	}
}

