// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class JavaKeyStore : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkJavaKeyStoreU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkJavaKeyStoreU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkJavaKeyStoreU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkJavaKeyStoreU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getNumPrivateKeysW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getNumPrivateKeysW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getNumSecretKeysW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getNumSecretKeysW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getNumTrustedCertsW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getNumTrustedCertsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getRequireCompleteChainW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getRequireCompleteChainW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_putRequireCompleteChainW", CharSet = CharSet.Unicode)]
        private static extern void CkJavaKeyStoreU_putRequireCompleteChainW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkJavaKeyStoreU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getVerifyKeyedDigestW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_getVerifyKeyedDigestW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_putVerifyKeyedDigestW", CharSet = CharSet.Unicode)]
        private static extern void CkJavaKeyStoreU_putVerifyKeyedDigestW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_AddPfxW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_AddPfxW(System.IntPtr pObj, System.IntPtr pfx, string alias, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_AddPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_AddPrivateKeyW(System.IntPtr pObj, System.IntPtr cert, string alias, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_AddSecretKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_AddSecretKeyW(System.IntPtr pObj, string encodedKeyBytes, string encoding, string algorithm, string alias, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_AddTrustedCertW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_AddTrustedCertW(System.IntPtr pObj, System.IntPtr cert, string alias);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ChangePasswordW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_ChangePasswordW(System.IntPtr pObj, int index, string oldPassword, string newPassword);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_FindCertChainW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_FindCertChainW(System.IntPtr pObj, string alias, int caseSensitive);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_FindPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_FindPrivateKeyW(System.IntPtr pObj, string password, string alias, int caseSensitive);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_FindTrustedCertW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_FindTrustedCertW(System.IntPtr pObj, string alias, int caseSensitive);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_GetCertChainW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_GetCertChainW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_GetPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_GetPrivateKeyW(System.IntPtr pObj, string password, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getPrivateKeyAliasW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_getPrivateKeyAliasW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getSecretKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_getSecretKeyW(System.IntPtr pObj, string password, int index, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getSecretKeyAliasW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_getSecretKeyAliasW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_GetTrustedCertW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_GetTrustedCertW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_getTrustedCertAliasW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_getTrustedCertAliasW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_LoadBdW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_LoadBdW(System.IntPtr pObj, string password, System.IntPtr bd);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_LoadBinaryW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_LoadBinaryW(System.IntPtr pObj, string password, System.IntPtr jksData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_LoadEncodedW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_LoadEncodedW(System.IntPtr pObj, string password, string jksEncData, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_LoadFileW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_LoadFileW(System.IntPtr pObj, string password, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_LoadJwkSetW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_LoadJwkSetW(System.IntPtr pObj, string password, System.IntPtr jwkSet);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_RemoveEntryW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_RemoveEntryW(System.IntPtr pObj, int entryType, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_SetAliasW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_SetAliasW(System.IntPtr pObj, int entryType, int index, string alias);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ToBinaryW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_ToBinaryW(System.IntPtr pObj, string password, System.IntPtr pRetVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_toEncodedStringW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_toEncodedStringW(System.IntPtr pObj, string password, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ToFileW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_ToFileW(System.IntPtr pObj, string password, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ToJwkSetW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_ToJwkSetW(System.IntPtr pObj, string password, System.IntPtr sbJwkSet);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ToPemW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_ToPemW(System.IntPtr pObj, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_ToPfxW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJavaKeyStoreU_ToPfxW(System.IntPtr pObj, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_UnlockComponentW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_UnlockComponentW(System.IntPtr pObj, string unlockCode);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJavaKeyStoreU_UseCertVaultW", CharSet = CharSet.Unicode)]
        private static extern int CkJavaKeyStoreU_UseCertVaultW(System.IntPtr pObj, System.IntPtr vault);


		public JavaKeyStore()
		{
			m_pObj = CkJavaKeyStoreU_CreateW();
			m_needDisposal = true;
		}

		public JavaKeyStore(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkJavaKeyStoreU_DisposeW(p);
			}
		}

		~JavaKeyStore()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = JavaKeyStore
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkJavaKeyStoreU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkJavaKeyStoreU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkJavaKeyStoreU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkJavaKeyStoreU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkJavaKeyStoreU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkJavaKeyStoreU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJavaKeyStoreU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of private keys contained within the keystore. Each private key has
	/// an alias and certificate chain associated with it.
	/// </summary>
	public int NumPrivateKeys
	{
		get
		{
			return CkJavaKeyStoreU_getNumPrivateKeysW(m_pObj);
		}
	}

	/// <summary>
	/// The number of secret keys (such as AES keys) contained within the keystore. Each
	/// secret key can have an alias associated with it.
	/// </summary>
	public int NumSecretKeys
	{
		get
		{
			return CkJavaKeyStoreU_getNumSecretKeysW(m_pObj);
		}
	}

	/// <summary>
	/// The number of trusted certificates contained within the keystore. Each
	/// certificate has an alias (identifying string) associated with it.
	/// </summary>
	public int NumTrustedCerts
	{
		get
		{
			return CkJavaKeyStoreU_getNumTrustedCertsW(m_pObj);
		}
	}

	/// <summary>
	/// If true, then adding a private key to the JKS only succeeds if the certificate
	/// chain can be completed to the root certificate. A root certificate is either a
	/// trusted CA root or a self-signed certificate. If false, then incomplete
	/// certificate chains are allowed. The default value is true.
	/// </summary>
	public bool RequireCompleteChain
	{
		get
		{
			return (CkJavaKeyStoreU_getRequireCompleteChainW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJavaKeyStoreU_putRequireCompleteChainW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkJavaKeyStoreU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJavaKeyStoreU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If true, then the keystore's keyed digest is required to pass validation
	/// (password required) for any of the load methods (such as LoadFile, LoadBinary,
	/// or LoadEncoded). If false, then a keystore may be loaded into memory without
	/// password validation (if a null or empty string is passed to the load method).
	/// The default value of this property is true.
	/// </summary>
	public bool VerifyKeyedDigest
	{
		get
		{
			return (CkJavaKeyStoreU_getVerifyKeyedDigestW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJavaKeyStoreU_putVerifyKeyedDigestW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkJavaKeyStoreU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Adds the contents of a PFX or PKCS #12 (.p12) to the Java keystore object. One
	/// JKS entry per private key found in the PKCS12 is added. The certs found within
	/// the PCKS12 are used to build the certificate chains for each private key. (A
	/// typical PFX file contains a single private key along with its associated
	/// certificate, and the certificates in the chain of authentication to the root CA
	/// cert.)
	/// 
	/// This method does not add trusted certificate entries to the JKS.
	/// 
	/// The specified alias is applied to the 1st private key found. If the alias is
	/// empty, then the alias is obtained from the cert/PFX in the following order of
	/// preference:
	///     Certificate's subject common name
	///     Certificate's subject email address
	///     Certificate's friendly name found in the PKCS9 attributes of the PKCS12
	///     Certificate's serial number
	/// 
	/// If multiple private keys are found in the PKCS12, then all but the first will
	/// automaticallly be assigned aliases using the preference just described.
	/// 
	/// The UseCertVault method may be called to provide additional certificates for the
	/// automatic construction of the certificate chains. If the RequireCompleteChain
	/// property is set to true, then this method will fail if any certificate chain
	/// is not completed to the root. The TrustedRoots class may be used to provide a
	/// source for obtaining trusted CA roots if these are not already present within
	/// the PKCS12.
	/// 
	///
	/// </summary>
	public bool AddPfx(Pfx pfx, string alias, string password)
	{
		int result = CkJavaKeyStoreU_AddPfxW(m_pObj, pfx == null ? System.IntPtr.Zero : pfx.getImpl(), alias, password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds a private key entry to the JKS. Both the private key and certificate chain
	/// are obtained from the certificate object that is passed in the 1st argument.
	/// 
	/// If the alias is empty, then the alias is automatically chosen based on the
	/// certificate's information, in the following order of preference:
	///     Certificate's subject common name
	///     Certificate's subject email address
	///     Certificate's serial number
	/// 
	/// The UseCertVault method may be called to provide additional certificates for the
	/// automatic construction of the certificate chains. If the RequireCompleteChain
	/// property is set to true, then this method will fail if the certificate chain
	/// is not completed to the root. The TrustedRoots class may be used to provide a
	/// source for obtaining trusted CA roots.
	/// 
	///
	/// </summary>
	public bool AddPrivateKey(Cert cert, string alias, string password)
	{
		int result = CkJavaKeyStoreU_AddPrivateKeyW(m_pObj, cert == null ? System.IntPtr.Zero : cert.getImpl(), alias, password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds a secret (symmetric) key entry to the JKS. This adds a symmetric key, which
	/// is simply a number of binary bytes (such as 16 bytes for a 128-bit AES key). The
	/// encodedKeyBytes provides the actual bytes of the symmetric key, in an encoded string form.
	/// The encoding indicates the encoding of encodedKeyBytes (such as "base64", "hex", "base64url",
	/// etc.) The algorithm describes the symmetric algorithm, such as "AES". The alias is the
	/// password used to seal (encrypt) the key bytes.
	/// 
	/// Note: The algorithm describes the usage of the encodedKeyBytes. For example, if encodedKeyBytes contains
	/// the 16 bytes of a 128-bit AES key, then algorithm should be set to "AES". The actual
	/// encryption algorithm used to seal the key within the JCEKS is
	/// PBEWithMD5AndTripleDES, which is part of the JCEKS specification.
	/// 
	///
	/// </summary>
	public bool AddSecretKey(string encodedKeyBytes, string encoding, string algorithm, string alias, string password)
	{
		int result = CkJavaKeyStoreU_AddSecretKeyW(m_pObj, encodedKeyBytes, encoding, algorithm, alias, password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds a trusted certificate to the Java keystore object.
	/// </summary>
	public bool AddTrustedCert(Cert cert, string alias)
	{
		int result = CkJavaKeyStoreU_AddTrustedCertW(m_pObj, cert == null ? System.IntPtr.Zero : cert.getImpl(), alias);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Changes the password for a private key.
	/// </summary>
	public bool ChangePassword(int index, string oldPassword, string newPassword)
	{
		int result = CkJavaKeyStoreU_ChangePasswordW(m_pObj, index, oldPassword, newPassword);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Finds and returns the certificate chain for the private key with the specified
	/// alias.
	/// </summary>
	public CertChain FindCertChain(string alias, bool caseSensitive)
	{
		System.IntPtr result = CkJavaKeyStoreU_FindCertChainW(m_pObj, alias, caseSensitive == false ? 0 : 1);
		if (result == IntPtr.Zero) return null;
		return new CertChain(result);
	}
	/// <summary>
	/// Finds and returns the private key with the specified alias.
	/// </summary>
	public PrivateKey FindPrivateKey(string password, string alias, bool caseSensitive)
	{
		System.IntPtr result = CkJavaKeyStoreU_FindPrivateKeyW(m_pObj, password, alias, caseSensitive == false ? 0 : 1);
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// Finds and returns the trusted certificate with the specified alias.
	/// </summary>
	public Cert FindTrustedCert(string alias, bool caseSensitive)
	{
		System.IntPtr result = CkJavaKeyStoreU_FindTrustedCertW(m_pObj, alias, caseSensitive == false ? 0 : 1);
		if (result == IntPtr.Zero) return null;
		return new Cert(result);
	}
	/// <summary>
	/// Returns the certificate chain associated with the Nth private key contained
	/// within the keystore. The 1st private key is at index 0.
	/// </summary>
	public CertChain GetCertChain(int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_GetCertChainW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new CertChain(result);
	}
	/// <summary>
	/// Returns the Nth private key contained within the keystore. The 1st private key
	/// is at index 0.
	/// </summary>
	public PrivateKey GetPrivateKey(string password, int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_GetPrivateKeyW(m_pObj, password, index);
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// Returns the Nth private key alias contained within the keystore. The 1st private
	/// key is at index 0.
	/// </summary>
	public string GetPrivateKeyAlias(int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_getPrivateKeyAliasW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the Nth secret key contained within the keystore. The 1st secret key is
	/// at index 0. The bytes of the secret key are returned in the specified encoding.
	/// (such as hex, base64, base64url, etc.)
	/// </summary>
	public string GetSecretKey(string password, int index, string encoding)
	{
		System.IntPtr result = CkJavaKeyStoreU_getSecretKeyW(m_pObj, password, index, encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the Nth secret key alias contained within the keystore. The 1st secret
	/// key is at index 0.
	/// </summary>
	public string GetSecretKeyAlias(int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_getSecretKeyAliasW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the Nth trusted certificate contained within the keystore. The 1st
	/// certificate is at index 0.
	/// </summary>
	public Cert GetTrustedCert(int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_GetTrustedCertW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new Cert(result);
	}
	/// <summary>
	/// Returns the Nth trusted certificate alias contained within the keystore. The 1st
	/// certificate is at index 0.
	/// </summary>
	public string GetTrustedCertAlias(int index)
	{
		System.IntPtr result = CkJavaKeyStoreU_getTrustedCertAliasW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Loads a Java keystore from the contents of bd.
	/// </summary>
	public bool LoadBd(string password, BinData bd)
	{
		int result = CkJavaKeyStoreU_LoadBdW(m_pObj, password, bd == null ? System.IntPtr.Zero : bd.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a Java keystore from in-memory byte data.
	/// </summary>
	public bool LoadBinary(string password, byte[] jksData)
	{
		System.IntPtr hInData1 = newCkByteData();
		System.IntPtr pInBytes1 = ckFromBytes(jksData,hInData1);
		int result = CkJavaKeyStoreU_LoadBinaryW(m_pObj, password, hInData1);
		if (pInBytes1 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes1);
		disposeCkByteData(hInData1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a Java keystore from an encoded string (such as base64, hex, etc.)
	/// </summary>
	public bool LoadEncoded(string password, string jksEncData, string encoding)
	{
		int result = CkJavaKeyStoreU_LoadEncodedW(m_pObj, password, jksEncData, encoding);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a Java keystore from a file.
	/// </summary>
	public bool LoadFile(string password, string path)
	{
		int result = CkJavaKeyStoreU_LoadFileW(m_pObj, password, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the Java KeyStore from a JSON Web Key (JWK) Set.
	/// </summary>
	public bool LoadJwkSet(string password, JsonObject jwkSet)
	{
		int result = CkJavaKeyStoreU_LoadJwkSetW(m_pObj, password, jwkSet == null ? System.IntPtr.Zero : jwkSet.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Removes the Nth trusted certificate or private key entry from the keystore. The
	/// entryType indicates whether it is a trusted root or private key entry (1 = trusted
	/// certificate entry, 2 = private key entry). The 1st entry is at index 0.
	/// </summary>
	public bool RemoveEntry(int entryType, int index)
	{
		int result = CkJavaKeyStoreU_RemoveEntryW(m_pObj, entryType, index);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkJavaKeyStoreU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the alias name for a trusted certificate or private key entry. The entryType
	/// indicates whether it is a trusted root or private key entry (1 = trusted
	/// certificate entry, 2 = private key entry). The 1st entry is at index 0.
	/// </summary>
	public bool SetAlias(int entryType, int index, string alias)
	{
		int result = CkJavaKeyStoreU_SetAliasW(m_pObj, entryType, index, alias);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Writes the key store to in-memory bytes. The password is used for the keyed hash of
	/// the entire JKS file. (Each private key within the file may use different
	/// passwords, and these are provided when the private key is added via the
	/// AddPrivateKey method.)
	/// </summary>
	public byte[] ToBinary(string password)
	{
		System.IntPtr hResultData = newCkByteData();
		CkJavaKeyStoreU_ToBinaryW(m_pObj, password, hResultData);
		byte[] retBytes = ckToBytes(hResultData);
		disposeCkByteData(hResultData);
		return retBytes;
	}
	/// <summary>
	/// Writes the key store to an encoded string. The encoding can be any encoding such as
	/// "base64" or "hex". The password is used for the keyed hash of the entire JKS file.
	/// (Each private key within the file may use different passwords, and these are
	/// provided when the private key is added via the AddPrivateKey method.)
	/// </summary>
	public string ToEncodedString(string password, string encoding)
	{
		System.IntPtr result = CkJavaKeyStoreU_toEncodedStringW(m_pObj, password, encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Writes the key store to a file. The password is used for the keyed hash of the
	/// entire JKS file. (Each private key within the file may use different passwords,
	/// and these are provided when the private key is added via the AddPrivateKey
	/// method.)
	/// </summary>
	public bool ToFile(string password, string path)
	{
		int result = CkJavaKeyStoreU_ToFileW(m_pObj, password, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the private keys in JSON JWK Set format. The JWK identifier (kid) will
	/// be set from the key alias in the store.
	/// </summary>
	public bool ToJwkSet(string password, StringBuilder sbJwkSet)
	{
		int result = CkJavaKeyStoreU_ToJwkSetW(m_pObj, password, sbJwkSet == null ? System.IntPtr.Zero : sbJwkSet.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the Java KeyStore as a Pem object.
	/// </summary>
	public Pem ToPem(string password)
	{
		System.IntPtr result = CkJavaKeyStoreU_ToPemW(m_pObj, password);
		if (result == IntPtr.Zero) return null;
		return new Pem(result);
	}
	/// <summary>
	/// Returns the Java KeyStore as a Pfx object.
	/// </summary>
	public Pfx ToPfx(string password)
	{
		System.IntPtr result = CkJavaKeyStoreU_ToPfxW(m_pObj, password);
		if (result == IntPtr.Zero) return null;
		return new Pfx(result);
	}
	/// <summary>
	/// Unlocks the component allowing for the full functionality to be used. If a
	/// purchased unlock code is passed, there is no expiration. Any other string
	/// automatically begins a fully-functional 30-day trial the first time
	/// UnlockComponent is called.
	/// </summary>
	public bool UnlockComponent(string unlockCode)
	{
		int result = CkJavaKeyStoreU_UnlockComponentW(m_pObj, unlockCode);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds an XML certificate vault to the object's internal list of sources to be
	/// searched for certificates for help in building certificate chains to a root
	/// certificate.
	/// </summary>
	public bool UseCertVault(XmlCertVault vault)
	{
		int result = CkJavaKeyStoreU_UseCertVaultW(m_pObj, vault == null ? System.IntPtr.Zero : vault.getImpl());
		return result == 0 ? false : true;
	}


	}
}

