// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Jwt : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkJwtU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkJwtU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_getAutoCompactW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_getAutoCompactW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_putAutoCompactW", CharSet = CharSet.Unicode)]
        private static extern void CkJwtU_putAutoCompactW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkJwtU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkJwtU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkJwtU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_createJwtW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_createJwtW(System.IntPtr pObj, string header, string payload, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_createJwtPkW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_createJwtPkW(System.IntPtr pObj, string header, string payload, System.IntPtr key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_GenNumericDateW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_GenNumericDateW(System.IntPtr pObj, int numSecOffset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_getHeaderW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_getHeaderW(System.IntPtr pObj, string token);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_getPayloadW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwtU_getPayloadW(System.IntPtr pObj, string token);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_IsTimeValidW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_IsTimeValidW(System.IntPtr pObj, string jwt, int leeway);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_VerifyJwtW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_VerifyJwtW(System.IntPtr pObj, string token, string password);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwtU_VerifyJwtPkW", CharSet = CharSet.Unicode)]
        private static extern int CkJwtU_VerifyJwtPkW(System.IntPtr pObj, string token, System.IntPtr key);


		public Jwt()
		{
			m_pObj = CkJwtU_CreateW();
			m_needDisposal = true;
		}

		public Jwt(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkJwtU_DisposeW(p);
			}
		}

		~Jwt()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Jwt
	/// <summary>
	/// If true, the JSON passed to CreateJwt and CreateJwtPk will be compacted to
	/// remove unnecessary whitespace. This will result in the smallest possible JWT.
	/// The default value is true.
	/// </summary>
	public bool AutoCompact
	{
		get
		{
			return (CkJwtU_getAutoCompactW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwtU_putAutoCompactW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkJwtU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkJwtU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkJwtU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkJwtU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkJwtU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkJwtU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwtU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkJwtU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwtU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkJwtU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Creates a JWT. The header is the JOSE JSON header. It can be the full JOSE JSON,
	/// or it can be a shorthand string such as "HS256", "HS384", or "HS512", in which
	/// case the standard JOSE header for the given algorithm will be used.
	/// 
	/// The payload is the JSON payload that contains the claims. The password is the secret.
	/// Given that the secret is a shared passwod string, this method should only be
	/// called for creating JWT's where the JOSE header's "alg" is HS256, HS384, or
	/// HS512. For RS256, RS384, RS512, ES256, ES384, and ES512, call CreateJwtPk
	/// instead.
	/// 
	/// When successful, this method returns a JWT with the format xxxxx.yyyyy.zzzzz,
	/// where xxxxx is the base64url encoded JOSE header, yyyyy is the base64url encoded
	/// payload, and zzzzz is the base64url signature.
	/// 
	///
	/// </summary>
	public string CreateJwt(string header, string payload, string password)
	{
		System.IntPtr result = CkJwtU_createJwtW(m_pObj, header, payload, password);
		return ckFromUni(result);
	}
	/// <summary>
	/// Creates a JWT using an RSA or ECC private key. The header is the JOSE JSON header.
	/// It can be the full JOSE JSON, or it can be a shorthand string such as "RS256",
	/// "RS384", "RS512", "ES256", "ES384", or "ES512", in which case the standard JOSE
	/// header for the given algorithm will be used.
	/// 
	/// The payload is the JSON payload that contains the claims. The key is the private
	/// key. This method should only be called for creating JWT's where the JOSE
	/// header's "alg" is RS256, RS384, RS512, ES256, ES384, and ES512. If the secret is
	/// a shared password string, then call CreateJwt instead.
	/// 
	/// When successful, this method returns a JWT with the format xxxxx.yyyyy.zzzzz,
	/// where xxxxx is the base64url encoded JOSE header, yyyyy is the base64url encoded
	/// payload, and zzzzz is the base64url signature.
	/// 
	///
	/// </summary>
	public string CreateJwtPk(string header, string payload, PrivateKey key)
	{
		System.IntPtr result = CkJwtU_createJwtPkW(m_pObj, header, payload, key == null ? System.IntPtr.Zero : key.getImpl());
		return ckFromUni(result);
	}
	/// <summary>
	/// Generates a JSON numeric value representing the number of seconds from
	/// 1970-01-01T00:00:00Z UTC until the specified UTC date/time, ignoring leap
	/// seconds. The date/time generated is equal to the current system time plus the
	/// number of seconds specified by numSecOffset. The numSecOffset can be negative.
	/// </summary>
	public int GenNumericDate(int numSecOffset)
	{
		int result = CkJwtU_GenNumericDateW(m_pObj, numSecOffset);
		return result;
	}
	/// <summary>
	/// Decodes the first part of a JWT (the "xxxxx" part of the "xxxxx.yyyyy.zzzzz"
	/// JWT) and returns the JSON string. This is the JOSE header of the JWT.
	/// </summary>
	public string GetHeader(string token)
	{
		System.IntPtr result = CkJwtU_getHeaderW(m_pObj, token);
		return ckFromUni(result);
	}
	/// <summary>
	/// Decodes the second part of a JWT (the "yyyyy" part of the "xxxxx.yyyyy.zzzzz"
	/// JWT) and returns the JSON string. This is the claims payload of the JWT.
	/// </summary>
	public string GetPayload(string token)
	{
		System.IntPtr result = CkJwtU_getPayloadW(m_pObj, token);
		return ckFromUni(result);
	}
	/// <summary>
	/// Verifies the "exp" and/or "nbf" claims and returns true if the current system
	/// date/time is within range. Returns false if the current system date/time is
	/// outside the allowed range of time. The leeway may be set to a non-zero number of
	/// seconds to allow for some small leeway (usually no more than a few minutes) to
	/// account for clock skew.
	/// </summary>
	public bool IsTimeValid(string jwt, int leeway)
	{
		int result = CkJwtU_IsTimeValidW(m_pObj, jwt, leeway);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkJwtU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies a JWT that requires a shared password string for verification. The token
	/// should be a JWT with the format xxxxx.yyyyy.zzzzz. This method should only be
	/// called for JWT's using the HS256, HS384, or HS512 algorithms. The VerifyJwtPk
	/// method should be called for verifying JWT's requiring an RSA or ECC key.
	/// 
	/// Returns true if the signature was verified. Returns false if the signature
	/// was not successfully verified.
	/// 
	/// Note: This method will return false if the "alg" in the JOSE header is
	/// anything other than the algorithms specifically for HMAC, namely "hs256,
	/// "hs384", and "hs512". For example, if the "alg" is "none", then this method
	/// immediately returns a failed status.
	/// 
	/// Further Explanation: This method calculates the signature using the password
	/// provided by the application, and compares it against the signature found in the
	/// JWT. If the signatures are equal, then the password is correct, and true is
	/// returned.
	/// 
	///
	/// </summary>
	public bool VerifyJwt(string token, string password)
	{
		int result = CkJwtU_VerifyJwtW(m_pObj, token, password);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies a JWT that requires an RSA or ECC public key for verification. The token
	/// should be a JWT with the format xxxxx.yyyyy.zzzzz. This method should only be
	/// called for JWT's using the RS256, RS384, RS512, ES256, ES384, or ES512
	/// algorithms.
	/// 
	/// Returns true if the signature was verified. Returns false if the signature
	/// was not successfully verified.
	/// 
	/// Note: This method will return false if the "alg" in the JOSE header is
	/// anything other than the algorithms specifically for RSA and ECC. For example, if
	/// the "alg" is "none", then this method immediately returns a failed status.
	/// 
	/// Further Explanation: This method calculates the signature using the key
	/// provided by the application, and compares it against the signature found in the
	/// JWT. If the signatures are equal, then the key corresponds to the private key
	/// used to sign, and true is returned.
	/// 
	///
	/// </summary>
	public bool VerifyJwtPk(string token, PublicKey key)
	{
		int result = CkJwtU_VerifyJwtPkW(m_pObj, token, key == null ? System.IntPtr.Zero : key.getImpl());
		return result == 0 ? false : true;
	}


	}
}

