// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Log : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkLogU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkLogU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkLogU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkLogU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkLogU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkLogU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkLogU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkLogU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkLogU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_ClearW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_ClearW(System.IntPtr pObj, string initialTag);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_EnterContextW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_EnterContextW(System.IntPtr pObj, string tag);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LeaveContextW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LeaveContextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogDataW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogDataW(System.IntPtr pObj, string tag, string message);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogDataBase64W", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogDataBase64W(System.IntPtr pObj, string tag, System.IntPtr data);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogDataHexW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogDataHexW(System.IntPtr pObj, string tag, System.IntPtr data);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogDataMaxW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogDataMaxW(System.IntPtr pObj, string tag, string message, int maxNumChars);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogDateTimeW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogDateTimeW(System.IntPtr pObj, string tag, int gmt);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogErrorW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogErrorW(System.IntPtr pObj, string message);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogInfoW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogInfoW(System.IntPtr pObj, string message);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogIntW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogIntW(System.IntPtr pObj, string tag, int value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogInt64W", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogInt64W(System.IntPtr pObj, string tag, long value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_LogTimestampW", CharSet = CharSet.Unicode)]
        private static extern void CkLogU_LogTimestampW(System.IntPtr pObj, string tag);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkLogU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkLogU_SaveLastErrorW(System.IntPtr pObj, string path);


		public Log()
		{
			m_pObj = CkLogU_CreateW();
			m_needDisposal = true;
		}

		public Log(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkLogU_DisposeW(p);
			}
		}

		~Log()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Log
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkLogU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkLogU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkLogU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkLogU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkLogU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkLogU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkLogU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkLogU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkLogU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkLogU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Clears the log. The initialTag is the initial top-level context tag for the new log.
	/// </summary>
	public void Clear(string initialTag)
	{
		CkLogU_ClearW(m_pObj, initialTag);
		return;
	}
	/// <summary>
	/// Enters a new context labelled with the given tag. Must be paired with a matching
	/// call to LeaveContext.
	/// </summary>
	public void EnterContext(string tag)
	{
		CkLogU_EnterContextW(m_pObj, tag);
		return;
	}
	/// <summary>
	/// Leaves the current context. A context that is entered and exited without any
	/// logging within the context is automatically removed from the log. (To say it
	/// another way: Empty contexts are automaticallly removed from the log upon leaving
	/// the context.)
	/// </summary>
	public void LeaveContext()
	{
		CkLogU_LeaveContextW(m_pObj);
		return;
	}
	/// <summary>
	/// Adds a tagged message to the log (i.e. a name/value pair).
	/// </summary>
	public void LogData(string tag, string message)
	{
		CkLogU_LogDataW(m_pObj, tag, message);
		return;
	}
	/// <summary>
	/// Logs binary data in base64 format.
	/// </summary>
	public void LogDataBase64(string tag, byte[] data)
	{
		System.IntPtr hInData1 = newCkByteData();
		System.IntPtr pInBytes1 = ckFromBytes(data,hInData1);
		CkLogU_LogDataBase64W(m_pObj, tag, hInData1);
		if (pInBytes1 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes1);
		disposeCkByteData(hInData1);
		return;
	}
	/// <summary>
	/// Logs binary data in hex format.
	/// </summary>
	public void LogDataHex(string tag, byte[] data)
	{
		System.IntPtr hInData1 = newCkByteData();
		System.IntPtr pInBytes1 = ckFromBytes(data,hInData1);
		CkLogU_LogDataHexW(m_pObj, tag, hInData1);
		if (pInBytes1 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes1);
		disposeCkByteData(hInData1);
		return;
	}
	/// <summary>
	/// Logs a string, but only up to the 1st maxNumChars characters of the string.
	/// </summary>
	public void LogDataMax(string tag, string message, int maxNumChars)
	{
		CkLogU_LogDataMaxW(m_pObj, tag, message, maxNumChars);
		return;
	}
	/// <summary>
	/// Logs the current date/time in RFC822 format. If gmt is true, then the GMT/UTC
	/// time is logged. Otherwise it is the local time.
	/// </summary>
	public void LogDateTime(string tag, bool gmt)
	{
		CkLogU_LogDateTimeW(m_pObj, tag, gmt == false ? 0 : 1);
		return;
	}
	/// <summary>
	/// Logs an error within the current context.
	/// </summary>
	public void LogError(string message)
	{
		CkLogU_LogErrorW(m_pObj, message);
		return;
	}
	/// <summary>
	/// Logs an informational message within the current context.
	/// </summary>
	public void LogInfo(string message)
	{
		CkLogU_LogInfoW(m_pObj, message);
		return;
	}
	/// <summary>
	/// Logs an integer.
	/// </summary>
	public void LogInt(string tag, int value)
	{
		CkLogU_LogIntW(m_pObj, tag, value);
		return;
	}
	/// <summary>
	/// Logs a 64-bit integer.
	/// </summary>
	public void LogInt64(string tag, long value)
	{
		CkLogU_LogInt64W(m_pObj, tag, value);
		return;
	}
	/// <summary>
	/// Logs the current time in HH:MM:SS:mmm format.
	/// </summary>
	public void LogTimestamp(string tag)
	{
		CkLogU_LogTimestampW(m_pObj, tag);
		return;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkLogU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}


	}
}

