// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class StringTable : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkStringTableU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkStringTableU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_getCountW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_getCountW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkStringTableU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkStringTableU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkStringTableU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_AppendW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_AppendW(System.IntPtr pObj, string value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_AppendFromFileW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_AppendFromFileW(System.IntPtr pObj, int maxLineLen, string charset, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_AppendFromSbW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_AppendFromSbW(System.IntPtr pObj, System.IntPtr sb);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_ClearW", CharSet = CharSet.Unicode)]
        private static extern void CkStringTableU_ClearW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_FindSubstringW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_FindSubstringW(System.IntPtr pObj, int startIndex, string substr, int caseSensitive);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_getStringsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_getStringsW(System.IntPtr pObj, int startIdx, int count, int crlf);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_IntAtW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_IntAtW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_SaveToFileW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_SaveToFileW(System.IntPtr pObj, string charset, int bCrlf, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_SortW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_SortW(System.IntPtr pObj, int ascending, int caseSensitive);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_SplitAndAppendW", CharSet = CharSet.Unicode)]
        private static extern int CkStringTableU_SplitAndAppendW(System.IntPtr pObj, string inStr, string delimiterChar, int exceptDoubleQuoted, int exceptEscaped);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkStringTableU_stringAtW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkStringTableU_stringAtW(System.IntPtr pObj, int index);


		public StringTable()
		{
			m_pObj = CkStringTableU_CreateW();
			m_needDisposal = true;
		}

		public StringTable(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkStringTableU_DisposeW(p);
			}
		}

		~StringTable()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = StringTable
	/// <summary>
	/// The number of strings in the table.
	/// </summary>
	public int Count
	{
		get
		{
			return CkStringTableU_getCountW(m_pObj);
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkStringTableU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkStringTableU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkStringTableU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkStringTableU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkStringTableU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkStringTableU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkStringTableU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkStringTableU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkStringTableU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkStringTableU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Appends a string to the table.
	/// </summary>
	public bool Append(string value)
	{
		int result = CkStringTableU_AppendW(m_pObj, value);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Appends strings, one per line, from a file. Each line in the path should be no
	/// longer than the length specified in maxLineLen. The charset indicates the character
	/// encoding of the contents of the file, such as "utf-8", "iso-8859-1",
	/// "Shift_JIS", etc.
	/// </summary>
	public bool AppendFromFile(int maxLineLen, string charset, string path)
	{
		int result = CkStringTableU_AppendFromFileW(m_pObj, maxLineLen, charset, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Appends strings, one per line, from the contents of a StringBuilder object.
	/// </summary>
	public bool AppendFromSb(StringBuilder sb)
	{
		int result = CkStringTableU_AppendFromSbW(m_pObj, sb == null ? System.IntPtr.Zero : sb.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Removes all the strings from the table.
	/// </summary>
	public void Clear()
	{
		CkStringTableU_ClearW(m_pObj);
		return;
	}
	/// <summary>
	/// Return the index of the first string in the table containing substr. Begins
	/// searching strings starting at startIndex. If caseSensitive is true, then the search is case
	/// sensitive. If caseSensitive is false then the search is case insensitive. Returns -1 if
	/// the substr is not found.
	/// </summary>
	public int FindSubstring(int startIndex, string substr, bool caseSensitive)
	{
		int result = CkStringTableU_FindSubstringW(m_pObj, startIndex, substr, caseSensitive == false ? 0 : 1);
		return result;
	}
	/// <summary>
	/// Return the number of strings specified by count, one per line, starting at startIdx.
	/// To return the entire table, pass 0 values for both startIdx and count. Set crlf equal
	/// to true to emit with CRLF line endings, or false to emit LF-only line
	/// endings. The last string is emitted includes the line ending.
	/// </summary>
	public string GetStrings(int startIdx, int count, bool crlf)
	{
		System.IntPtr result = CkStringTableU_getStringsW(m_pObj, startIdx, count, crlf == false ? 0 : 1);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the Nth string in the table, converted to an integer value. The index is
	/// 0-based. (The first string is at index 0.) Returns -1 if no string is found at
	/// the specified index. Returns 0 if the string at the specified index exist, but
	/// is not an integer.
	/// </summary>
	public int IntAt(int index)
	{
		int result = CkStringTableU_IntAtW(m_pObj, index);
		return result;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkStringTableU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the string table to a file. The charset is the character encoding to use,
	/// such as "utf-8", "iso-8859-1", "windows-1252", "Shift_JIS", "gb2312", etc. If
	/// bCrlf is true, then CRLF line endings are used, otherwise LF-only line endings
	/// are used.
	/// </summary>
	public bool SaveToFile(string charset, bool bCrlf, string path)
	{
		int result = CkStringTableU_SaveToFileW(m_pObj, charset, bCrlf == false ? 0 : 1, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sorts the strings in the collection in ascending or descending order. To sort in
	/// ascending order, set ascending to true, otherwise set ascending equal to false.
	/// </summary>
	public bool Sort(bool ascending, bool caseSensitive)
	{
		int result = CkStringTableU_SortW(m_pObj, ascending == false ? 0 : 1, caseSensitive == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Splits a string into parts based on a single character delimiterChar. If exceptDoubleQuoted is true,
	/// then the delimiter char found between double quotes is not treated as a
	/// delimiter. If exceptEscaped is true, then an escaped (with a backslash) delimiter char
	/// is not treated as a delimiter.
	/// </summary>
	public bool SplitAndAppend(string inStr, string delimiterChar, bool exceptDoubleQuoted, bool exceptEscaped)
	{
		int result = CkStringTableU_SplitAndAppendW(m_pObj, inStr, delimiterChar, exceptDoubleQuoted == false ? 0 : 1, exceptEscaped == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the Nth string in the table. The index is 0-based. (The first string is
	/// at index 0.)
	/// </summary>
	public string StringAt(int index)
	{
		System.IntPtr result = CkStringTableU_stringAtW(m_pObj, index);
		return ckFromUni(result);
	}


	}
}

