// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class AuthAzureStorage : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkAuthAzureStorageU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkAuthAzureStorageU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_accessKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_accessKeyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putAccessKeyW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putAccessKeyW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_accountW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_accountW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putAccountW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putAccountW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureStorageU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_schemeW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_schemeW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putSchemeW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putSchemeW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_serviceW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_serviceW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putServiceW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putServiceW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureStorageU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_xMsVersionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkAuthAzureStorageU_xMsVersionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_putXMsVersionW", CharSet = CharSet.Unicode)]
        private static extern void CkAuthAzureStorageU_putXMsVersionW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkAuthAzureStorageU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkAuthAzureStorageU_SaveLastErrorW(System.IntPtr pObj, string path);


		public AuthAzureStorage()
		{
			m_pObj = CkAuthAzureStorageU_CreateW();
			m_needDisposal = true;
		}

		public AuthAzureStorage(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkAuthAzureStorageU_DisposeW(p);
			}
		}

		~AuthAzureStorage()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = AuthAzureStorage
	/// <summary>
	/// A valid base64 access key for the Azure storage account.
	/// </summary>
	public string AccessKey
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_accessKeyW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putAccessKeyW(m_pObj, value);
		}
	}

	/// <summary>
	/// The Azure storage account name. (A storage account can contain zero or more
	/// containers. A container contains properties, metadata, and zero or more blobs. A
	/// blob is any single entity comprised of binary data, properties, and metadata. )
	/// </summary>
	public string Account
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_accountW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putAccountW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkAuthAzureStorageU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthAzureStorageU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Can be "SharedKey" or "SharedKeyLite". The default value is "SharedKey".
	/// </summary>
	public string Scheme
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_schemeW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putSchemeW(m_pObj, value);
		}
	}

	/// <summary>
	/// Can be "Blob", "Queue", "File", or "Table". The default is "Blob".
	/// 
	/// Note: Authentication for the "Table" service did not work in versions prior to
	/// v9.5.0.83.
	/// 
	///
	/// </summary>
	public string Service
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_serviceW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putServiceW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkAuthAzureStorageU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkAuthAzureStorageU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// If set, automatically adds the "x-ms-version" HTTP request header to Azure
	/// Storage requests. The default value is "2014-02-14".
	/// </summary>
	public string XMsVersion
	{
		get
		{
			return ckFromUni(CkAuthAzureStorageU_xMsVersionW(m_pObj));
		}
		set
		{
			CkAuthAzureStorageU_putXMsVersionW(m_pObj, value);
		}
	}

	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkAuthAzureStorageU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}


	}
}

