// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Cache : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkCacheU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkCacheU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkCacheU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastEtagFetchedW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastEtagFetchedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastExpirationFetchedStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastExpirationFetchedStrW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getLastHitExpiredW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_getLastHitExpiredW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_lastKeyFetchedW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_lastKeyFetchedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCacheU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getLevelW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_getLevelW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_putLevelW", CharSet = CharSet.Unicode)]
        private static extern void CkCacheU_putLevelW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getNumRootsW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_getNumRootsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkCacheU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_AddRootW", CharSet = CharSet.Unicode)]
        private static extern void CkCacheU_AddRootW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DeleteAllW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_DeleteAllW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DeleteAllExpiredW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_DeleteAllExpiredW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DeleteFromCacheW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_DeleteFromCacheW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DeleteOlderDtW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_DeleteOlderDtW(System.IntPtr pObj, System.IntPtr dateTime);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_DeleteOlderStrW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_DeleteOlderStrW(System.IntPtr pObj, string dateTimeStr);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_FetchFromCacheW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_FetchFromCacheW(System.IntPtr pObj, string key, System.IntPtr pRetVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_fetchTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_fetchTextW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getEtagW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_getEtagW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_GetExpirationDtW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_GetExpirationDtW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getExpirationStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_getExpirationStrW(System.IntPtr pObj, string url);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getFilenameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_getFilenameW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_getRootW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCacheU_getRootW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_IsCachedW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_IsCachedW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveTextDtW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveTextDtW(System.IntPtr pObj, string key, System.IntPtr expireDateTime, string eTag, string itemTextData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveTextNoExpireW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveTextNoExpireW(System.IntPtr pObj, string key, string eTag, string itemTextData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveTextStrW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveTextStrW(System.IntPtr pObj, string key, string expireDateTime, string eTag, string itemTextData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveToCacheDtW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveToCacheDtW(System.IntPtr pObj, string key, System.IntPtr expireDateTime, string eTag, System.IntPtr itemData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveToCacheNoExpireW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveToCacheNoExpireW(System.IntPtr pObj, string key, string eTag, System.IntPtr itemData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_SaveToCacheStrW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_SaveToCacheStrW(System.IntPtr pObj, string key, string expireDateTime, string eTag, System.IntPtr itemData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_UpdateExpirationDtW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_UpdateExpirationDtW(System.IntPtr pObj, string key, System.IntPtr expireDateTime);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCacheU_UpdateExpirationStrW", CharSet = CharSet.Unicode)]
        private static extern int CkCacheU_UpdateExpirationStrW(System.IntPtr pObj, string key, string expireDateTime);


		public Cache()
		{
			m_pObj = CkCacheU_CreateW();
			m_needDisposal = true;
		}

		public Cache(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkCacheU_DisposeW(p);
			}
		}

		~Cache()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Cache
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkCacheU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkCacheU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkCacheU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkCacheU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkCacheU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// The ETag of the last item fetched from cache.
	/// </summary>
	public string LastEtagFetched
	{
		get
		{
			return ckFromUni(CkCacheU_lastEtagFetchedW(m_pObj));
		}
	}

	/// <summary>
	/// Expiration date/time of the last item fetched from cache in RFC822 string
	/// format.
	/// </summary>
	public string LastExpirationFetchedStr
	{
		get
		{
			return ckFromUni(CkCacheU_lastExpirationFetchedStrW(m_pObj));
		}
	}

	/// <summary>
	/// true if the LastExpirationFetched is before the current date/time. Otherwise
	/// false.
	/// </summary>
	public bool LastHitExpired
	{
		get
		{
			return (CkCacheU_getLastHitExpiredW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// The key of the last item fetched from cache. (For web pages, the key is
	/// typically the canonicalized URL. Otherwise, the key is a unique identifer used
	/// to access the cached item.)
	/// </summary>
	public string LastKeyFetched
	{
		get
		{
			return ckFromUni(CkCacheU_lastKeyFetchedW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkCacheU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCacheU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of directory levels in the cache. Possible values are:
	/// 
	///     0: All cache files are in a single directory (the cache root).
	/// 
	///     1: Cache files are located in 256 sub-directories numbered 0 .. 255 directly
	///     under the cache root.
	/// 
	///     2: There are two levels of sub-directories under the cache root. The 1st
	///     level has 256 sub-directories numbered 0 .. 255 directly under the cache root.
	///     The 2nd level allows for up to 256 sub-directories (0..255) under each level-1
	///     directory. Cache files are stored in the leaf directories.
	/// 
	///
	/// </summary>
	public int Level
	{
		get
		{
			return CkCacheU_getLevelW(m_pObj);
		}
		set
		{
			CkCacheU_putLevelW(m_pObj, value);
		}
	}

	/// <summary>
	/// The number of root directories composing the cache. A typical multi-root cache
	/// would place each root on a separate hard drive.
	/// </summary>
	public int NumRoots
	{
		get
		{
			return CkCacheU_getNumRootsW(m_pObj);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkCacheU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCacheU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkCacheU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Must be called once for each cache root. For example, if the cache is spread
	/// across D:\cacheRoot, E:\cacheRoot, and F:\cacheRoot, an application would setup
	/// the cache object by calling AddRoot three times -- once with "D:\cacheRoot",
	/// once with "E:\cacheRoot", and once with "F:\cacheRoot".
	/// </summary>
	public void AddRoot(string path)
	{
		CkCacheU_AddRootW(m_pObj, path);
		return;
	}
	/// <summary>
	/// Deletes all items in the cache. This method completely clears the cache. All
	/// files in the cache are deleted. (If the cache is multi-level, existing
	/// sub-directories are not deleted.)
	/// 
	/// Returns the number of items (i.e. cache files) deleted.
	/// 
	///
	/// </summary>
	public int DeleteAll()
	{
		int result = CkCacheU_DeleteAllW(m_pObj);
		return result;
	}
	/// <summary>
	/// Deletes all expired items from the cache.
	/// 
	/// Returns the number of items (i.e. cache files) deleted.
	/// 
	///
	/// </summary>
	public int DeleteAllExpired()
	{
		int result = CkCacheU_DeleteAllExpiredW(m_pObj);
		return result;
	}
	/// <summary>
	/// Deletes a single item from the disk cache. Returns false if the item exists in
	/// cache but could not be deleted. Otherwise returns true.
	/// </summary>
	public bool DeleteFromCache(string key)
	{
		int result = CkCacheU_DeleteFromCacheW(m_pObj, key);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as DeleteOlder, except the dateTime is passed as a CkDateTime.
	/// </summary>
	public int DeleteOlderDt(CkDateTime dateTime)
	{
		int result = CkCacheU_DeleteOlderDtW(m_pObj, dateTime == null ? System.IntPtr.Zero : dateTime.getImpl());
		return result;
	}
	/// <summary>
	/// The same as DeleteOlder, except the dateTimeStr is passed as a date/time in RFC822
	/// format.
	/// </summary>
	public int DeleteOlderStr(string dateTimeStr)
	{
		int result = CkCacheU_DeleteOlderStrW(m_pObj, dateTimeStr);
		return result;
	}
	/// <summary>
	/// Fetches an item from cache.
	/// 
	/// The key may be any length and may include any characters. It should uniquely
	/// identify the cached item. (No two items in the cache should have the same key.)
	/// 
	///
	/// </summary>
	public byte[] FetchFromCache(string key)
	{
		System.IntPtr hResultData = newCkByteData();
		CkCacheU_FetchFromCacheW(m_pObj, key, hResultData);
		byte[] retBytes = ckToBytes(hResultData);
		disposeCkByteData(hResultData);
		return retBytes;
	}
	/// <summary>
	/// Fetches a text item from the cache and returns it's text content.
	/// 
	/// The key may be any length and may include any characters. It should uniquely
	/// identify the cached item. (No two items in the cache should have the same key.)
	/// 
	///
	/// </summary>
	public string FetchText(string key)
	{
		System.IntPtr result = CkCacheU_fetchTextW(m_pObj, key);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the eTag for an item in the cache.
	/// </summary>
	public string GetEtag(string key)
	{
		System.IntPtr result = CkCacheU_getEtagW(m_pObj, key);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the expiration date/time for an item in the cache as a CkDateTime
	/// object.
	/// </summary>
	public CkDateTime GetExpirationDt(string key)
	{
		System.IntPtr result = CkCacheU_GetExpirationDtW(m_pObj, key);
		if (result == IntPtr.Zero) return null;
		return new CkDateTime(result);
	}
	/// <summary>
	/// Returns the expiration date/time for an item in the cache in RFC822 string
	/// format.
	/// </summary>
	public string GetExpirationStr(string url)
	{
		System.IntPtr result = CkCacheU_getExpirationStrW(m_pObj, url);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the absolute file path of the cache file associated with the key.
	/// </summary>
	public string GetFilename(string key)
	{
		System.IntPtr result = CkCacheU_getFilenameW(m_pObj, key);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the directory path of the Nth cache root. (Indexing begins at 0.)
	/// </summary>
	public string GetRoot(int index)
	{
		System.IntPtr result = CkCacheU_getRootW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns true if the item is found in the cache, otherwise returns false.
	/// </summary>
	public bool IsCached(string key)
	{
		int result = CkCacheU_IsCachedW(m_pObj, key);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkCacheU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as SaveText, except the expire date/time is passed as a CkDateTime
	/// object.
	/// </summary>
	public bool SaveTextDt(string key, CkDateTime expireDateTime, string eTag, string itemTextData)
	{
		int result = CkCacheU_SaveTextDtW(m_pObj, key, expireDateTime == null ? System.IntPtr.Zero : expireDateTime.getImpl(), eTag, itemTextData);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Inserts or replaces an text item in the cache with no expiration date/time. The
	/// eTag is optional and may be set to a zero-length string. Applications may use it
	/// as a place to save additional information about the cached item.
	/// </summary>
	public bool SaveTextNoExpire(string key, string eTag, string itemTextData)
	{
		int result = CkCacheU_SaveTextNoExpireW(m_pObj, key, eTag, itemTextData);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as SaveText, except the expire date/time is passed as a string in
	/// RFC822 format.
	/// </summary>
	public bool SaveTextStr(string key, string expireDateTime, string eTag, string itemTextData)
	{
		int result = CkCacheU_SaveTextStrW(m_pObj, key, expireDateTime, eTag, itemTextData);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as SaveToCache, except the expire date/time is passed as a CkDateTime
	/// object.
	/// </summary>
	public bool SaveToCacheDt(string key, CkDateTime expireDateTime, string eTag, byte[] itemData)
	{
		System.IntPtr hInData3 = newCkByteData();
		System.IntPtr pInBytes3 = ckFromBytes(itemData,hInData3);
		int result = CkCacheU_SaveToCacheDtW(m_pObj, key, expireDateTime == null ? System.IntPtr.Zero : expireDateTime.getImpl(), eTag, hInData3);
		if (pInBytes3 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes3);
		disposeCkByteData(hInData3);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Inserts or replaces an item in the cache. The cached item will have no
	/// expiration. The eTag is optional and may be set to a zero-length string.
	/// Applications may use it as a place to save additional information about the
	/// cached item.
	/// </summary>
	public bool SaveToCacheNoExpire(string key, string eTag, byte[] itemData)
	{
		System.IntPtr hInData2 = newCkByteData();
		System.IntPtr pInBytes2 = ckFromBytes(itemData,hInData2);
		int result = CkCacheU_SaveToCacheNoExpireW(m_pObj, key, eTag, hInData2);
		if (pInBytes2 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes2);
		disposeCkByteData(hInData2);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as SaveToCache, except the expire date/time is passed in RFC822 string
	/// format.
	/// </summary>
	public bool SaveToCacheStr(string key, string expireDateTime, string eTag, byte[] itemData)
	{
		System.IntPtr hInData3 = newCkByteData();
		System.IntPtr pInBytes3 = ckFromBytes(itemData,hInData3);
		int result = CkCacheU_SaveToCacheStrW(m_pObj, key, expireDateTime, eTag, hInData3);
		if (pInBytes3 != System.IntPtr.Zero) Marshal.FreeHGlobal(pInBytes3);
		disposeCkByteData(hInData3);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as UpdateExpiration, except the expireDateTime is passed as a CkDateTime.
	/// </summary>
	public bool UpdateExpirationDt(string key, CkDateTime expireDateTime)
	{
		int result = CkCacheU_UpdateExpirationDtW(m_pObj, key, expireDateTime == null ? System.IntPtr.Zero : expireDateTime.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// The same as UpdateExpiration, except the expireDateTime is passed in RFC822 string format.
	/// </summary>
	public bool UpdateExpirationStr(string key, string expireDateTime)
	{
		int result = CkCacheU_UpdateExpirationStrW(m_pObj, key, expireDateTime);
		return result == 0 ? false : true;
	}


	}
}

