// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CertChain : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkCertChainU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkCertChainU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkCertChainU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCertChainU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_getNumCertsW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_getNumCertsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_getNumExpiredCertsW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_getNumExpiredCertsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_getReachesRootW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_getReachesRootW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkCertChainU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_GetCertW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_GetCertW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_IsRootTrustedW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_IsRootTrustedW(System.IntPtr pObj, System.IntPtr trustedRoots);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_LoadX5CW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_LoadX5CW(System.IntPtr pObj, System.IntPtr jwk);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_VerifyCertSignaturesW", CharSet = CharSet.Unicode)]
        private static extern int CkCertChainU_VerifyCertSignaturesW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCertChainU_x509PKIPathv1W", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCertChainU_x509PKIPathv1W(System.IntPtr pObj);


		public CertChain()
		{
			m_pObj = CkCertChainU_CreateW();
			m_needDisposal = true;
		}

		public CertChain(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkCertChainU_DisposeW(p);
			}
		}

		~CertChain()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = CertChain
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkCertChainU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkCertChainU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkCertChainU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkCertChainU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkCertChainU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkCertChainU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertChainU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of certificates in the chain. The end-user subscriber certificate is
	/// at index 0. This is the certificate most removed from the trusted root.
	/// Intermediate certificates are at indices 1 to NumCerts - 2. The trusted root (or
	/// self-signed certificate) is at index NumCerts - 1.
	/// </summary>
	public int NumCerts
	{
		get
		{
			return CkCertChainU_getNumCertsW(m_pObj);
		}
	}

	/// <summary>
	/// Returns the number of certificates in the chain that have expired.
	/// </summary>
	public int NumExpiredCerts
	{
		get
		{
			return CkCertChainU_getNumExpiredCertsW(m_pObj);
		}
	}

	/// <summary>
	/// true if this certificate chain extends all the way to the root certificate.
	/// The root certificate is either a trusted CA root or a self-signed certificate.
	/// In both cases, the issuer of a root certificate is itself.
	/// </summary>
	public bool ReachesRoot
	{
		get
		{
			return (CkCertChainU_getReachesRootW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkCertChainU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCertChainU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkCertChainU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Returns the Nth certificate in the chain.
	/// </summary>
	public Cert GetCert(int index)
	{
		System.IntPtr result = CkCertChainU_GetCertW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new Cert(result);
	}
	/// <summary>
	/// Returns true if the root of the certificate chain is a certificate found in
	/// trustedRoots.
	/// </summary>
	public bool IsRootTrusted(TrustedRoots trustedRoots)
	{
		int result = CkCertChainU_IsRootTrustedW(m_pObj, trustedRoots == null ? System.IntPtr.Zero : trustedRoots.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a certificate chain from the "x5c" parameter of a JWK (JSON Web Key).
	/// </summary>
	public bool LoadX5C(JsonObject jwk)
	{
		int result = CkCertChainU_LoadX5CW(m_pObj, jwk == null ? System.IntPtr.Zero : jwk.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkCertChainU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies the certificate signatures to the root. Returns true if all
	/// certificate signatures are valid.
	/// </summary>
	public bool VerifyCertSignatures()
	{
		int result = CkCertChainU_VerifyCertSignaturesW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the base64 representation of an X509PKIPathv1 containing the
	/// certificates in this chain. This is typically used in an X.509 Binary Security
	/// Token. It is a PKIPath that contains an ordered list of X.509 public
	/// certificates packaged in a PKIPath. The X509PKIPathv1 token type may be used to
	/// represent a certificate path. (This is sometimes used in XAdES signatures.)
	/// </summary>
	public string X509PKIPathv1()
	{
		System.IntPtr result = CkCertChainU_x509PKIPathv1W(m_pObj);
		return ckFromUni(result);
	}


	}
}

