// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CreateCS : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkCreateCSU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkCreateCSU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkCreateCSU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkCreateCSU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkCreateCSU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_getReadOnlyW", CharSet = CharSet.Unicode)]
        private static extern int CkCreateCSU_getReadOnlyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_putReadOnlyW", CharSet = CharSet.Unicode)]
        private static extern void CkCreateCSU_putReadOnlyW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkCreateCSU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkCreateCSU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_CreateFileStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_CreateFileStoreW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_CreateMemoryStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_CreateMemoryStoreW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_CreateRegistryStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_CreateRegistryStoreW(System.IntPtr pObj, string regRoot, string regPath);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenChilkatStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenChilkatStoreW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenCurrentUserStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenCurrentUserStoreW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenFileStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenFileStoreW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenLocalSystemStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenLocalSystemStoreW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenOutlookStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenOutlookStoreW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_OpenRegistryStoreW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkCreateCSU_OpenRegistryStoreW(System.IntPtr pObj, string regRoot, string regPath);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkCreateCSU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkCreateCSU_SaveLastErrorW(System.IntPtr pObj, string path);


		public CreateCS()
		{
			m_pObj = CkCreateCSU_CreateW();
			m_needDisposal = true;
		}

		public CreateCS(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkCreateCSU_DisposeW(p);
			}
		}

		~CreateCS()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = CreateCS
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkCreateCSU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkCreateCSU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkCreateCSU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkCreateCSU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkCreateCSU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkCreateCSU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCreateCSU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Determines whether certificate stores are opened with read-only or read/write
	/// permissions. Only applies to methods such as OpenCurrentUserStore, where the a
	/// readOnly parameter is not present.
	/// </summary>
	public bool ReadOnly
	{
		get
		{
			return (CkCreateCSU_getReadOnlyW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCreateCSU_putReadOnlyW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkCreateCSU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkCreateCSU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkCreateCSU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Creates a file-based certificate store. If 'filename' already exists, the method
	/// will fail.
	/// </summary>
	public CertStore CreateFileStore(string path)
	{
		System.IntPtr result = CkCreateCSU_CreateFileStoreW(m_pObj, path);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Creates a temporary certificate store in memory that is initially empty.
	/// </summary>
	public CertStore CreateMemoryStore()
	{
		System.IntPtr result = CkCreateCSU_CreateMemoryStoreW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Creates a registry-based certificate store. The 'hiveName' can either be
	/// "CurrentUser" or "LocalMachine". The 'regPath' argument should be specified
	/// without a leading slash, such as "Software/Chilkat/MyCertStore".
	/// </summary>
	public CertStore CreateRegistryStore(string regRoot, string regPath)
	{
		System.IntPtr result = CkCreateCSU_CreateRegistryStoreW(m_pObj, regRoot, regPath);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens the certificate store used by Chilkat Mail and returns the object
	/// representing that store.
	/// </summary>
	public CertStore OpenChilkatStore()
	{
		System.IntPtr result = CkCreateCSU_OpenChilkatStoreW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens the local system's Current User Certificate Store and returns the object
	/// representing that store.
	/// </summary>
	public CertStore OpenCurrentUserStore()
	{
		System.IntPtr result = CkCreateCSU_OpenCurrentUserStoreW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens an existing file certificate store. To open it read-only, readOnly should
	/// be non-zero.
	/// </summary>
	public CertStore OpenFileStore(string path)
	{
		System.IntPtr result = CkCreateCSU_OpenFileStoreW(m_pObj, path);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens the local system's Local Machine Certificate Store and returns the object
	/// representing that store.
	/// </summary>
	public CertStore OpenLocalSystemStore()
	{
		System.IntPtr result = CkCreateCSU_OpenLocalSystemStoreW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens the certificate store used by Microsoft Outlook (and Office) and returns
	/// the object representing that store.
	/// </summary>
	public CertStore OpenOutlookStore()
	{
		System.IntPtr result = CkCreateCSU_OpenOutlookStoreW(m_pObj);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Opens an existing registry-based certificate store. 'hiveName' should be either
	/// "CurrentUser" or "LocalMachine". The 'regPath' argument should be specified
	/// without a leading slash, such as "Software/Chilkat/MyCertStore".
	/// </summary>
	public CertStore OpenRegistryStore(string regRoot, string regPath)
	{
		System.IntPtr result = CkCreateCSU_OpenRegistryStoreW(m_pObj, regRoot, regPath);
		if (result == IntPtr.Zero) return null;
		return new CertStore(result);
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkCreateCSU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}


	}
}

