// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Ecc : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkEccU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkEccU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkEccU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkEccU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkEccU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkEccU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkEccU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_GenEccKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_GenEccKeyW(System.IntPtr pObj, string curveName, System.IntPtr prng);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_GenEccKey2W", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_GenEccKey2W(System.IntPtr pObj, string curveName, string encodedK, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkEccU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_sharedSecretENCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_sharedSecretENCW(System.IntPtr pObj, System.IntPtr privKey, System.IntPtr pubKey, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_signBdW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_signBdW(System.IntPtr pObj, System.IntPtr bdData, string hashAlg, string encoding, System.IntPtr privKey, System.IntPtr prng);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_signHashENCW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkEccU_signHashENCW(System.IntPtr pObj, string encodedHash, string encoding, System.IntPtr privkey, System.IntPtr prng);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_VerifyBdW", CharSet = CharSet.Unicode)]
        private static extern int CkEccU_VerifyBdW(System.IntPtr pObj, System.IntPtr bdData, string hashAlg, string encodedSig, string encoding, System.IntPtr pubkey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkEccU_VerifyHashENCW", CharSet = CharSet.Unicode)]
        private static extern int CkEccU_VerifyHashENCW(System.IntPtr pObj, string encodedHash, string encodedSig, string encoding, System.IntPtr pubkey);


		public Ecc()
		{
			m_pObj = CkEccU_CreateW();
			m_needDisposal = true;
		}

		public Ecc(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkEccU_DisposeW(p);
			}
		}

		~Ecc()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Ecc
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkEccU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkEccU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkEccU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkEccU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkEccU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkEccU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkEccU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkEccU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkEccU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkEccU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Generates an ECDSA private key. The curveName specifies the curve name which
	/// determines the key size. The prng provides a source for generating the random
	/// private key.
	/// 
	/// The following curve names are accepted:
	///     secp256r1 (also known as P-256 and prime256v1)
	///     secp384r1 (also known as P-384)
	///     secp521r1 (also known as P-521)
	///     secp256k1 (This is the curve used for Bitcoin)
	///     secp192r1
	///     secp224r1
	///     brainpoolP160r1
	///     brainpoolP192r1
	///     brainpoolP192r1
	///     brainpoolP224r1
	///     brainpoolP256r1
	///     brainpoolP320r1
	///     brainpoolP384r1
	///     brainpoolP512r1
	/// 
	///
	/// </summary>
	public PrivateKey GenEccKey(string curveName, Prng prng)
	{
		System.IntPtr result = CkEccU_GenEccKeyW(m_pObj, curveName, prng == null ? System.IntPtr.Zero : prng.getImpl());
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// Generates an ECDSA private key using a specified value for K. The curveName specifies
	/// the curve name which determines the key size. The encodedK is the encoded value of
	/// the private key. The encoding is the encoding used for encodedK, which can be "hex",
	/// "base64", "decimal", etc.
	/// 
	/// Note: This method is typically used for testing -- such as when the same private
	/// key is desired to produce results identical from run to run.
	/// 
	/// The following curve names are accepted:
	///     secp256r1 (also known as P-256 and prime256v1)
	///     secp384r1 (also known as P-384)
	///     secp521r1 (also known as P-521)
	///     secp256k1 (This is the curve used for Bitcoin)
	///     secp192r1
	///     secp224r1
	///     brainpoolP160r1
	///     brainpoolP192r1
	///     brainpoolP192r1
	///     brainpoolP224r1
	///     brainpoolP256r1
	///     brainpoolP320r1
	///     brainpoolP384r1
	///     brainpoolP512r1
	/// 
	///
	/// </summary>
	public PrivateKey GenEccKey2(string curveName, string encodedK, string encoding)
	{
		System.IntPtr result = CkEccU_GenEccKey2W(m_pObj, curveName, encodedK, encoding);
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkEccU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Computes a shared secret given a private and public key. For example, Alice and
	/// Bob can compute the identical shared secret by doing the following: Alice sends
	/// Bob her public key, and Bob calls SharedSecretENC with his private key and
	/// Alice's public key. Bob sends Alice his public key, and Alice calls
	/// SharedSecretENC with her private key and Bob's public key. Both calls to
	/// SharedSecretENC will produce the same result. The resulting bytes are returned
	/// in encoded string form (hex, base64, etc) as specified by encoding.
	/// 
	/// Note: The private and public keys must both be keys on the same ECDSA curve.
	/// 
	///
	/// </summary>
	public string SharedSecretENC(PrivateKey privKey, PublicKey pubKey, string encoding)
	{
		System.IntPtr result = CkEccU_sharedSecretENCW(m_pObj, privKey == null ? System.IntPtr.Zero : privKey.getImpl(), pubKey == null ? System.IntPtr.Zero : pubKey.getImpl(), encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// This method is the same as SignHashENC, except the actual data to be signed and
	/// the name of the hash algorithm is passed in. The following hash algorithms are
	/// supported: sha256, sha384, and sha512.
	/// </summary>
	public string SignBd(BinData bdData, string hashAlg, string encoding, PrivateKey privKey, Prng prng)
	{
		System.IntPtr result = CkEccU_signBdW(m_pObj, bdData == null ? System.IntPtr.Zero : bdData.getImpl(), hashAlg, encoding, privKey == null ? System.IntPtr.Zero : privKey.getImpl(), prng == null ? System.IntPtr.Zero : prng.getImpl());
		return ckFromUni(result);
	}
	/// <summary>
	/// Computes an ECDSA signature on a hash. ECDSA signatures are computed and
	/// verified on the hashes of data (such as SHA1, SHA256, etc.). The hash of the
	/// data is passed in encodedHash. The encoding, such as "base64", "hex", etc. is passed in
	/// encoding. The ECDSA private key is passed in the 3rd argument (privkey). Given that
	/// creating an ECDSA signature involves the generation of random numbers, a PRNG is
	/// passed in the 4th argument (prng). The signature is returned as an encoded
	/// string using the encoding specified by the encoding argument.
	/// </summary>
	public string SignHashENC(string encodedHash, string encoding, PrivateKey privkey, Prng prng)
	{
		System.IntPtr result = CkEccU_signHashENCW(m_pObj, encodedHash, encoding, privkey == null ? System.IntPtr.Zero : privkey.getImpl(), prng == null ? System.IntPtr.Zero : prng.getImpl());
		return ckFromUni(result);
	}
	/// <summary>
	/// This method is the same as VerifyHashENC, except the actual data to be verified
	/// and the name of the hash algorithm is passed in. The following hash algorithms
	/// are supported: sha256, sha384, and sha512.
	/// </summary>
	public int VerifyBd(BinData bdData, string hashAlg, string encodedSig, string encoding, PublicKey pubkey)
	{
		int result = CkEccU_VerifyBdW(m_pObj, bdData == null ? System.IntPtr.Zero : bdData.getImpl(), hashAlg, encodedSig, encoding, pubkey == null ? System.IntPtr.Zero : pubkey.getImpl());
		return result;
	}
	/// <summary>
	/// Verifies an ECDSA signature. ECDSA signatures are computed and verified on the
	/// hashes of data (such as SHA1, SHA256, etc.). The hash of the data is passed in
	/// encodedHash. The encoded signature is passed in encodedSig. The encoding of both the hash and
	/// signature, such as "base64", "hex", etc. is passed in encoding. The ECDSA public key
	/// is passed in the last argument (pubkey).
	/// 
	/// The method returns 1 for a valid signature, 0 for an invalid signature, and -1
	/// for any other failure.
	/// 
	///
	/// </summary>
	public int VerifyHashENC(string encodedHash, string encodedSig, string encoding, PublicKey pubkey)
	{
		int result = CkEccU_VerifyHashENCW(m_pObj, encodedHash, encodedSig, encoding, pubkey == null ? System.IntPtr.Zero : pubkey.getImpl());
		return result;
	}


	}
}

