// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Jws : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkJwsU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkJwsU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkJwsU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkJwsU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getNumSignaturesW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_getNumSignaturesW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getPreferCompactW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_getPreferCompactW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_putPreferCompactW", CharSet = CharSet.Unicode)]
        private static extern void CkJwsU_putPreferCompactW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getPreferFlattenedW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_getPreferFlattenedW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_putPreferFlattenedW", CharSet = CharSet.Unicode)]
        private static extern void CkJwsU_putPreferFlattenedW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkJwsU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_createJwsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_createJwsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_CreateJwsSbW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_CreateJwsSbW(System.IntPtr pObj, System.IntPtr sbJws);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_getPayloadW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_getPayloadW(System.IntPtr pObj, string charset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_GetPayloadBdW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_GetPayloadBdW(System.IntPtr pObj, System.IntPtr binData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_GetPayloadSbW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_GetPayloadSbW(System.IntPtr pObj, string charset, System.IntPtr sbPayload);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_GetProtectedHeaderW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_GetProtectedHeaderW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_GetUnprotectedHeaderW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkJwsU_GetUnprotectedHeaderW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_LoadJwsW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_LoadJwsW(System.IntPtr pObj, string jwsStr);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_LoadJwsSbW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_LoadJwsSbW(System.IntPtr pObj, System.IntPtr sbJws);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetMacKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetMacKeyW(System.IntPtr pObj, int index, string key, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetMacKeyBdW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetMacKeyBdW(System.IntPtr pObj, int index, System.IntPtr key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetPayloadW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetPayloadW(System.IntPtr pObj, string payload, string charset, int includeBom);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetPayloadBdW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetPayloadBdW(System.IntPtr pObj, System.IntPtr binData);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetPayloadSbW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetPayloadSbW(System.IntPtr pObj, System.IntPtr sbPayload, string charset, int includeBom);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetPrivateKeyW(System.IntPtr pObj, int index, System.IntPtr privKey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetProtectedHeaderW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetProtectedHeaderW(System.IntPtr pObj, int index, System.IntPtr json);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetPublicKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetPublicKeyW(System.IntPtr pObj, int index, System.IntPtr pubKey);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_SetUnprotectedHeaderW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_SetUnprotectedHeaderW(System.IntPtr pObj, int index, System.IntPtr json);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkJwsU_ValidateW", CharSet = CharSet.Unicode)]
        private static extern int CkJwsU_ValidateW(System.IntPtr pObj, int index);


		public Jws()
		{
			m_pObj = CkJwsU_CreateW();
			m_needDisposal = true;
		}

		public Jws(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkJwsU_DisposeW(p);
			}
		}

		~Jws()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Jws
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkJwsU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkJwsU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkJwsU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkJwsU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkJwsU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkJwsU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwsU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of signatures contained in this JWS.
	/// </summary>
	public int NumSignatures
	{
		get
		{
			return CkJwsU_getNumSignaturesW(m_pObj);
		}
	}

	/// <summary>
	/// Controls whether to use the JWS Compact Serialization or JWS JSON Serialization
	/// when creating JWSs. The default value is true, which is to choose the compact
	/// serialization when possible. If multiple signatures exist, or if any unprotected
	/// headers exist, then JWS JSON Serialization is used regardless of this property
	/// setting.
	/// </summary>
	public bool PreferCompact
	{
		get
		{
			return (CkJwsU_getPreferCompactW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwsU_putPreferCompactW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Controls whether to use the flattened or general JWE JSON Serialization when
	/// creating JWSs. The default value is true, which is to choose the flattened
	/// serialization when possible. If multiple signatures exist, then the general
	/// (non-flattened) JWS JSON Serialization is used regardless of this property
	/// setting.
	/// </summary>
	public bool PreferFlattened
	{
		get
		{
			return (CkJwsU_getPreferFlattenedW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwsU_putPreferFlattenedW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkJwsU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkJwsU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkJwsU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Creates and returns the JWS containing one or more signatures according to the
	/// previously set payload, headers, and keys.
	/// </summary>
	public string CreateJws()
	{
		System.IntPtr result = CkJwsU_createJwsW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Creates and returns the JWS by appending it to the contents of sbJws.
	/// </summary>
	public bool CreateJwsSb(StringBuilder sbJws)
	{
		int result = CkJwsU_CreateJwsSbW(m_pObj, sbJws == null ? System.IntPtr.Zero : sbJws.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the JWS payload. The charset specifies the byte representation to be used
	/// in interpreting the bytes of the payload. (For example, "utf-8", "windows-1252",
	/// "utf-16", etc.)
	/// </summary>
	public string GetPayload(string charset)
	{
		System.IntPtr result = CkJwsU_getPayloadW(m_pObj, charset);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the JWS payload by appending it to the binData.
	/// </summary>
	public bool GetPayloadBd(BinData binData)
	{
		int result = CkJwsU_GetPayloadBdW(m_pObj, binData == null ? System.IntPtr.Zero : binData.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the JWS payload by appending it to the sbPayload. The charset specifies the byte
	/// representation to be used in interpreting the bytes of the payload. (For
	/// example, "utf-8", "windows-1252", "utf-16", etc.)
	/// </summary>
	public bool GetPayloadSb(string charset, StringBuilder sbPayload)
	{
		int result = CkJwsU_GetPayloadSbW(m_pObj, charset, sbPayload == null ? System.IntPtr.Zero : sbPayload.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the protected header for the Nth signature. The index is the index of the
	/// signature. The 1st signature is at index 0. In most cases, a JWS contains a
	/// single signature at index 0.
	/// </summary>
	public JsonObject GetProtectedHeader(int index)
	{
		System.IntPtr result = CkJwsU_GetProtectedHeaderW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new JsonObject(result);
	}
	/// <summary>
	/// Returns the optional unprotected header for the Nth signature. The index is the
	/// index of the signature. The 1st signature is at index 0. In most cases, a JWS
	/// contains a single signature at index 0.
	/// </summary>
	public JsonObject GetUnprotectedHeader(int index)
	{
		System.IntPtr result = CkJwsU_GetUnprotectedHeaderW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new JsonObject(result);
	}
	/// <summary>
	/// Loads a JWS contained in jwsStr.
	/// </summary>
	public bool LoadJws(string jwsStr)
	{
		int result = CkJwsU_LoadJwsW(m_pObj, jwsStr);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads a JWS from the contents of sbJws.
	/// </summary>
	public bool LoadJwsSb(StringBuilder sbJws)
	{
		int result = CkJwsU_LoadJwsSbW(m_pObj, sbJws == null ? System.IntPtr.Zero : sbJws.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkJwsU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the MAC key to be used for creating or validating a signature for the
	/// algorithms "HS256", "HS384", or "HS512". The key is an encoded string
	/// representation of the MAC key bytes. The encoding is an encoding, such as
	/// "base64url", "base64", "hex", etc. The 1st signature is at index 0. (Most JWSs
	/// only contain a single signature.)
	/// </summary>
	public bool SetMacKey(int index, string key, string encoding)
	{
		int result = CkJwsU_SetMacKeyW(m_pObj, index, key, encoding);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the MAC key to be used for creating or validating a signature for the
	/// algorithms "HS256", "HS384", or "HS512". The key contains the binary bytes of
	/// the MAC key for the Nth signature. The 1st signature is at index 0.
	/// </summary>
	public bool SetMacKeyBd(int index, BinData key)
	{
		int result = CkJwsU_SetMacKeyBdW(m_pObj, index, key == null ? System.IntPtr.Zero : key.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the JWS payload from the contents of payload. The charset specifies the byte
	/// representation to be used for the string that is to be the payload. (For
	/// example, "utf-8", "windows-1252", "utf-16", etc.). If includeBom is true, then the
	/// byte-order-mark (BOM), also known as preamble, if one exists for the given charset,
	/// is included in the payload. Normally, includeBom should be set to false.
	/// </summary>
	public bool SetPayload(string payload, string charset, bool includeBom)
	{
		int result = CkJwsU_SetPayloadW(m_pObj, payload, charset, includeBom == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the JWS payload from the contents of binData.
	/// </summary>
	public bool SetPayloadBd(BinData binData)
	{
		int result = CkJwsU_SetPayloadBdW(m_pObj, binData == null ? System.IntPtr.Zero : binData.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the JWS payload from the contents of sbPayload. The charset specifies the byte
	/// representation to be used for the string that is to be the payload. (For
	/// example, "utf-8", "windows-1252", "utf-16", etc.). If includeBom is true, then the
	/// byte-order-mark (BOM), also known as preamble, if one exists for the given charset,
	/// is included in the payload. Normally, includeBom should be set to false.
	/// </summary>
	public bool SetPayloadSb(StringBuilder sbPayload, string charset, bool includeBom)
	{
		int result = CkJwsU_SetPayloadSbW(m_pObj, sbPayload == null ? System.IntPtr.Zero : sbPayload.getImpl(), charset, includeBom == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the private key (ECC or RSA) to be used in creating a signature for the
	/// following algorithms:
	/// RS256
	/// RS384
	/// RS512
	/// ES256
	/// ES384
	/// ES512
	/// PS256
	/// PS384
	/// PS512
	/// The JWS algorithms are described in RFC 7518, section 3.1. Here is a summary:
	///    +--------------+-------------------------------+--------------------+
	///    | "alg" Param  | Digital Signature or MAC      | Implementation     |
	///    | Value        | Algorithm                     | Requirements       |
	///    +--------------+-------------------------------+--------------------+
	///    | HS256        | HMAC using SHA-256            | Required           |
	///    | HS384        | HMAC using SHA-384            | Optional           |
	///    | HS512        | HMAC using SHA-512            | Optional           |
	///    | RS256        | RSASSA-PKCS1-v1_5 using       | Recommended        |
	///    |              | SHA-256                       |                    |
	///    | RS384        | RSASSA-PKCS1-v1_5 using       | Optional           |
	///    |              | SHA-384                       |                    |
	///    | RS512        | RSASSA-PKCS1-v1_5 using       | Optional           |
	///    |              | SHA-512                       |                    |
	///    | ES256        | ECDSA using P-256 and SHA-256 | Recommended+       |
	///    | ES384        | ECDSA using P-384 and SHA-384 | Optional           |
	///    | ES512        | ECDSA using P-521 and SHA-512 | Optional           |
	///    | PS256        | RSASSA-PSS using SHA-256 and  | Optional           |
	///    |              | MGF1 with SHA-256             |                    |
	///    | PS384        | RSASSA-PSS using SHA-384 and  | Optional           |
	///    |              | MGF1 with SHA-384             |                    |
	///    | PS512        | RSASSA-PSS using SHA-512 and  | Optional           |
	///    |              | MGF1 with SHA-512             |                    |
	///    | none         | No digital signature or MAC   | Optional           |
	///    |              | performed                     |                    |
	///    +--------------+-------------------------------+--------------------+
	///
	/// </summary>
	public bool SetPrivateKey(int index, PrivateKey privKey)
	{
		int result = CkJwsU_SetPrivateKeyW(m_pObj, index, privKey == null ? System.IntPtr.Zero : privKey.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets a signature's protected header. The index is the index of the signature. The
	/// 1st signature is at index 0. In most cases, a JWS contains a single signature at
	/// index 0.
	/// </summary>
	public bool SetProtectedHeader(int index, JsonObject json)
	{
		int result = CkJwsU_SetProtectedHeaderW(m_pObj, index, json == null ? System.IntPtr.Zero : json.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets the public key (ECC or RSA) to be used in validating a signature for the
	/// following algorithms:
	/// RS256
	/// RS384
	/// RS512
	/// ES256
	/// ES384
	/// ES512
	/// PS256
	/// PS384
	/// PS512
	///
	/// </summary>
	public bool SetPublicKey(int index, PublicKey pubKey)
	{
		int result = CkJwsU_SetPublicKeyW(m_pObj, index, pubKey == null ? System.IntPtr.Zero : pubKey.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sets a signature's optional unprotected header. The index is the index of the
	/// signature. The 1st signature is at index 0. In most cases, a JWS contains a
	/// single signature at index 0.
	/// </summary>
	public bool SetUnprotectedHeader(int index, JsonObject json)
	{
		int result = CkJwsU_SetUnprotectedHeaderW(m_pObj, index, json == null ? System.IntPtr.Zero : json.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Validates the Nth signature or MAC using the Nth public key or MAC key.
	/// 
	/// Returns 1 if the signature was validated, thus verifying that the signer used
	/// the same MAC key or the matching private key.
	/// Returns 0 if the incorrect public key or MAC key was provided.
	/// Returns -1 for any other error, such as if no public key or MAC key was
	/// previously set for the given index.
	/// 
	/// Prior to calling this method, a program should provide the public key or MAC key
	/// via the SetPublicKey, SetMacKey, or SetMacKeyBd methods.
	/// 
	///
	/// </summary>
	public int Validate(int index)
	{
		int result = CkJwsU_ValidateW(m_pObj, index);
		return result;
	}


	}
}

