// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class KeyContainer : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkKeyContainerU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkKeyContainerU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_containerNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_containerNameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getIsMachineKeysetW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getIsMachineKeysetW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getIsOpenW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getIsOpenW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getLegacyKeySpecW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getLegacyKeySpecW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_putLegacyKeySpecW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_putLegacyKeySpecW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getMachineKeysW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getMachineKeysW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_putMachineKeysW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_putMachineKeysW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_CloseContainerW", CharSet = CharSet.Unicode)]
        private static extern void CkKeyContainerU_CloseContainerW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_CreateContainerW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_CreateContainerW(System.IntPtr pObj, string name, int machineKeyset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_DeleteContainerW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_DeleteContainerW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_DeleteKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_DeleteKeyW(System.IntPtr pObj, string keyName, string storageProvider);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_ExportKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_ExportKeyW(System.IntPtr pObj, string keyName, string storageProvider, int silentFlag, System.IntPtr key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_FetchContainerNamesW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_FetchContainerNamesW(System.IntPtr pObj, int bMachineKeyset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GenerateKeyPairW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_GenerateKeyPairW(System.IntPtr pObj, int bKeyExchangePair, int keyLengthInBits);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_generateUuidW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_generateUuidW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GetKeysW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_GetKeysW(System.IntPtr pObj, string storageProvider, System.IntPtr json);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_getNthContainerNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_getNthContainerNameW(System.IntPtr pObj, int bMachineKeyset, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GetNumContainersW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_GetNumContainersW(System.IntPtr pObj, int bMachineKeyset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GetPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_GetPrivateKeyW(System.IntPtr pObj, int bKeyExchangePair);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GetPublicKeyW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkKeyContainerU_GetPublicKeyW(System.IntPtr pObj, int bKeyExchangePair);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_GetStorageProvidersW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_GetStorageProvidersW(System.IntPtr pObj, System.IntPtr json);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_ImportKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_ImportKeyW(System.IntPtr pObj, string keyName, string storageProvider, int allowOverwrite, int allowExport, System.IntPtr key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_ImportPrivateKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_ImportPrivateKeyW(System.IntPtr pObj, System.IntPtr key, int bKeyExchangePair);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_ImportPublicKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_ImportPublicKeyW(System.IntPtr pObj, System.IntPtr key, int bKeyExchangePair);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_OpenContainerW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_OpenContainerW(System.IntPtr pObj, string name, int needPrivateKeyAccess, int machineKeyset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkKeyContainerU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkKeyContainerU_SaveLastErrorW(System.IntPtr pObj, string path);


		public KeyContainer()
		{
			m_pObj = CkKeyContainerU_CreateW();
			m_needDisposal = true;
		}

		public KeyContainer(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkKeyContainerU_DisposeW(p);
			}
		}

		~KeyContainer()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = KeyContainer
	/// <summary>
	/// The name of the currently open key container.
	/// </summary>
	public string ContainerName
	{
		get
		{
			return ckFromUni(CkKeyContainerU_containerNameW(m_pObj));
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkKeyContainerU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkKeyContainerU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// true if the currently open key container is from the machine keyset, otherwise
	/// false.
	/// </summary>
	public bool IsMachineKeyset
	{
		get
		{
			return (CkKeyContainerU_getIsMachineKeysetW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// true if the object currently has a key container open, otherwise false.
	/// </summary>
	public bool IsOpen
	{
		get
		{
			return (CkKeyContainerU_getIsOpenW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkKeyContainerU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkKeyContainerU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkKeyContainerU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkKeyContainerU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkKeyContainerU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If the storage provider is one for the legacy CryptoAPI, then this property
	/// indicate whether to work with AT_KEYEXCHANGE or AT_SIGNATURE. Possible values
	/// for this property are:
	///     1 - AT_KEYEXCHANGE
	///     2 - AT_SIGNATURE
	/// 
	/// The default value of this property is 1.
	/// 
	///
	/// </summary>
	public int LegacyKeySpec
	{
		get
		{
			return CkKeyContainerU_getLegacyKeySpecW(m_pObj);
		}
		set
		{
			CkKeyContainerU_putLegacyKeySpecW(m_pObj, value);
		}
	}

	/// <summary>
	/// If true, work with keys for the local computer. If false, work with keys for
	/// the current user. The default value is false.
	/// </summary>
	public bool MachineKeys
	{
		get
		{
			return (CkKeyContainerU_getMachineKeysW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkKeyContainerU_putMachineKeysW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkKeyContainerU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkKeyContainerU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkKeyContainerU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Closes the currently opened key container (if this object has one opened).
	/// </summary>
	public void CloseContainer()
	{
		CkKeyContainerU_CloseContainerW(m_pObj);
		return;
	}
	/// <summary>
	/// Creates a new key container with a given name in the machine or user keyset. If
	/// a key container having the same name already exists, it is opened.
	/// </summary>
	public bool CreateContainer(string name, bool machineKeyset)
	{
		int result = CkKeyContainerU_CreateContainerW(m_pObj, name, machineKeyset == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Deletes a key container with a given name in the machine or user keyset.
	/// </summary>
	public bool DeleteContainer()
	{
		int result = CkKeyContainerU_DeleteContainerW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Deletes a key from the storageProvider.
	/// </summary>
	public bool DeleteKey(string keyName, string storageProvider)
	{
		int result = CkKeyContainerU_DeleteKeyW(m_pObj, keyName, storageProvider);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Exports a key into key. If silentFlag is true, requests that the key service
	/// provider (KSP) not display any user interface. If the provider must display the
	/// UI to operate, the call fails
	/// </summary>
	public bool ExportKey(string keyName, string storageProvider, bool silentFlag, PrivateKey key)
	{
		int result = CkKeyContainerU_ExportKeyW(m_pObj, keyName, storageProvider, silentFlag == false ? 0 : 1, key == null ? System.IntPtr.Zero : key.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Fetches the container names for the machine or user keyset. After this method
	/// has been called successfully, the GetNumContainers method can be called to get
	/// the number of key containers in the given keyset, and the GetContainerName
	/// method can be called to retrieve each key container's name by index.
	/// </summary>
	public bool FetchContainerNames(bool bMachineKeyset)
	{
		int result = CkKeyContainerU_FetchContainerNamesW(m_pObj, bMachineKeyset == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Generates a new key pair in the currently open key container. Each key container
	/// can contain two public/private key pairs: one for key exchange, and one for
	/// signature creation. The 1st argument determines which key pair is generated. A
	/// value of true causes a new key-exchange key pair to be generated, a value of
	/// false causes a new signature key pair to be generated. The size of the key (in
	/// bits) can range from 384 to 16384, with a typical value being 1024 or 2048 bits.
	/// </summary>
	public bool GenerateKeyPair(bool bKeyExchangePair, int keyLengthInBits)
	{
		int result = CkKeyContainerU_GenerateKeyPairW(m_pObj, bKeyExchangePair == false ? 0 : 1, keyLengthInBits);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// This method is provided as a convenient way of generating unique key container
	/// names. There are no set rules for naming key containers. However, if your
	/// application is to generate a large number of keys, using a UUID for the key
	/// container name is wise to ensure uniqueness.
	/// </summary>
	public string GenerateUuid()
	{
		System.IntPtr result = CkKeyContainerU_generateUuidW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Loads json with a list of keys found in the given storageProvider.
	/// </summary>
	public bool GetKeys(string storageProvider, JsonObject json)
	{
		int result = CkKeyContainerU_GetKeysW(m_pObj, storageProvider, json == null ? System.IntPtr.Zero : json.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the Nth key container name. The FetchContainerNames method must have
	/// been previously called with the same keyset (machine or user). The index ranges
	/// from 0 to GetNumContainers() - 1.
	/// </summary>
	public string GetNthContainerName(bool bMachineKeyset, int index)
	{
		System.IntPtr result = CkKeyContainerU_getNthContainerNameW(m_pObj, bMachineKeyset == false ? 0 : 1, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the number of key containers in existence for the given keyset (machine
	/// or user). The FetchContainerNames method must have been previously called with
	/// the same keyset (machine or user).
	/// </summary>
	public int GetNumContainers(bool bMachineKeyset)
	{
		int result = CkKeyContainerU_GetNumContainersW(m_pObj, bMachineKeyset == false ? 0 : 1);
		return result;
	}
	/// <summary>
	/// A key container can hold two public/private key pairs -- a key-exchange pair and
	/// a signature pair. This method returns the private key for one of the key pairs.
	/// Passing a true returns the key-exchange pair, passing false returns the
	/// signature pair. A null reference is returned on failure.
	/// </summary>
	public PrivateKey GetPrivateKey(bool bKeyExchangePair)
	{
		System.IntPtr result = CkKeyContainerU_GetPrivateKeyW(m_pObj, bKeyExchangePair == false ? 0 : 1);
		if (result == IntPtr.Zero) return null;
		return new PrivateKey(result);
	}
	/// <summary>
	/// A key container can hold two public/private key pairs -- a key-exchange pair and
	/// a signature pair. This method returns the public key for one of the key pairs.
	/// Passing a true returns the key-exchange pair, passing false returns the
	/// signature pair. A null reference is returned on failure.
	/// </summary>
	public PublicKey GetPublicKey(bool bKeyExchangePair)
	{
		System.IntPtr result = CkKeyContainerU_GetPublicKeyW(m_pObj, bKeyExchangePair == false ? 0 : 1);
		if (result == IntPtr.Zero) return null;
		return new PublicKey(result);
	}
	/// <summary>
	/// Loads json with a list of storage providers on the Windows system.
	/// 
	/// The json will contain JSON such as this:
	/// {
	///   "cng": [
	///     "Microsoft Software Key Storage Provider",
	///     "Microsoft Passport Key Storage Provider",
	///     "Microsoft Platform Crypto Provider",
	///     "Microsoft Smart Card Key Storage Provider"
	///   ],
	///   "legacy": [
	///     "Microsoft Base Cryptographic Provider v1.0",
	///     "Microsoft Base DSS and Diffie-Hellman Cryptographic Provider",
	///     "Microsoft Base DSS Cryptographic Provider",
	///     "Microsoft Base Smart Card Crypto Provider",
	///     "Microsoft DH SChannel Cryptographic Provider",
	///     "Microsoft Enhanced Cryptographic Provider v1.0",
	///     "Microsoft Enhanced DSS and Diffie-Hellman Cryptographic Provider",
	///     "Microsoft Enhanced RSA and AES Cryptographic Provider",
	///     "Microsoft RSA SChannel Cryptographic Provider",
	///     "Microsoft Strong Cryptographic Provider"
	///   ]
	/// }
	/// 
	///
	/// </summary>
	public bool GetStorageProviders(JsonObject json)
	{
		int result = CkKeyContainerU_GetStorageProvidersW(m_pObj, json == null ? System.IntPtr.Zero : json.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Imports a new key into the storageProvider. If allowOverwrite is true, if a key already exists in
	/// the container with the specified name, the existing key will be overwritten. If
	/// allowOverwrite is false and the key already exists, then the method fails. If allowExport is
	/// true, then the key is marked as exportable, which allows for it to be
	/// re-exported to a PFX.
	/// </summary>
	public bool ImportKey(string keyName, string storageProvider, bool allowOverwrite, bool allowExport, PrivateKey key)
	{
		int result = CkKeyContainerU_ImportKeyW(m_pObj, keyName, storageProvider, allowOverwrite == false ? 0 : 1, allowExport == false ? 0 : 1, key == null ? System.IntPtr.Zero : key.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Imports a private key into the key container. The 1st argument is the private
	/// key to be imported, and the 2nd argument determines if the key-exchange private
	/// key (true) or signature private key (false) is replaced. Note: A private key
	/// actually contains the key material for both the public and private key. When you
	/// have a private key, you effectively have both the public and private key of a
	/// key pair.
	/// </summary>
	public bool ImportPrivateKey(PrivateKey key, bool bKeyExchangePair)
	{
		int result = CkKeyContainerU_ImportPrivateKeyW(m_pObj, key == null ? System.IntPtr.Zero : key.getImpl(), bKeyExchangePair == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Imports a public key into the key container. The 1st argument is the public key
	/// to be imported, and the 2nd argument determines if the key-exchange public key
	/// (true) or signature public key (false) is replaced.
	/// </summary>
	public bool ImportPublicKey(PublicKey key, bool bKeyExchangePair)
	{
		int result = CkKeyContainerU_ImportPublicKeyW(m_pObj, key == null ? System.IntPtr.Zero : key.getImpl(), bKeyExchangePair == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Opens an existing key container in either the machine or user keyset.
	/// </summary>
	public bool OpenContainer(string name, bool needPrivateKeyAccess, bool machineKeyset)
	{
		int result = CkKeyContainerU_OpenContainerW(m_pObj, name, needPrivateKeyAccess == false ? 0 : 1, machineKeyset == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkKeyContainerU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}


	}
}

