// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Pkcs11 : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkPkcs11U_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkPkcs11U_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkPkcs11U_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkPkcs11U_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_getNumCertsW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_getNumCertsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_sharedLibPathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_sharedLibPathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_putSharedLibPathW", CharSet = CharSet.Unicode)]
        private static extern void CkPkcs11U_putSharedLibPathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkPkcs11U_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkPkcs11U_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_CloseSessionW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_CloseSessionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_DiscoverW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_DiscoverW(System.IntPtr pObj, int onlyTokensPresent, System.IntPtr json);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_FindAllCertsW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_FindAllCertsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_FindCertW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_FindCertW(System.IntPtr pObj, string certPart, string partValue, System.IntPtr cert);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_GetCertW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_GetCertW(System.IntPtr pObj, int index, System.IntPtr cert);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_InitializeW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_InitializeW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_InitPinW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_InitPinW(System.IntPtr pObj, string pin);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_InitTokenW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_InitTokenW(System.IntPtr pObj, int slotId, string pin, string tokenLabel);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_LoginW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_LoginW(System.IntPtr pObj, int userType, string pin);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_LogoutW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_LogoutW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_OpenSessionW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_OpenSessionW(System.IntPtr pObj, int slotId, int readWrite);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkPkcs11U_SetPinW", CharSet = CharSet.Unicode)]
        private static extern int CkPkcs11U_SetPinW(System.IntPtr pObj, string oldPin, string newPin);


		public Pkcs11()
		{
			m_pObj = CkPkcs11U_CreateW();
			m_needDisposal = true;
		}

		public Pkcs11(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkPkcs11U_DisposeW(p);
			}
		}

		~Pkcs11()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Pkcs11
	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkPkcs11U_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkPkcs11U_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkPkcs11U_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkPkcs11U_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkPkcs11U_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkPkcs11U_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkPkcs11U_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of certificates contained on the smart card or USB token. This
	/// property is set when FindAllCerts is called.
	/// </summary>
	public int NumCerts
	{
		get
		{
			return CkPkcs11U_getNumCertsW(m_pObj);
		}
	}

	/// <summary>
	/// On Windows systems, then should be set to the name of the DLL file (if the DLL
	/// is located in C:\Windows\System32), or it can be the full path to the DLL.
	/// 
	/// On Linux, MacOSX, or other non-Windows systems, this can also be either the full
	/// path to the .so or .dylib, or just the .so or .dylib filename. On these systems,
	/// Chilkat calls thedlopen system function
	/// &lt;https://man7.org/linux/man-pages/man3/dlopen.3.html&gt; to load the shared
	/// library. If just the filename is passed in, the directories searched are those
	/// indicated in the dlopen function description
	/// athttps://man7.org/linux/man-pages/man3/dlopen.3.html
	/// &lt;https://man7.org/linux/man-pages/man3/dlopen.3.html&gt;
	/// 
	///
	/// </summary>
	public string SharedLibPath
	{
		get
		{
			return ckFromUni(CkPkcs11U_sharedLibPathW(m_pObj));
		}
		set
		{
			CkPkcs11U_putSharedLibPathW(m_pObj, value);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkPkcs11U_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkPkcs11U_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkPkcs11U_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Closes the session on the token (i.e. smart card).
	/// 
	/// Note: Memory leaks can occur if the session is not properly closed.
	/// 
	///
	/// </summary>
	public bool CloseSession()
	{
		int result = CkPkcs11U_CloseSessionW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Discovers the readers, smart cards, and USB tokens accessible via PKCS11 on the
	/// computer (using the DLL/shared lib specified by SharedLibPath). The onlyTokensPresent
	/// specifies if only slots (readers) with tokens (smart cards) present should be
	/// returned. The information is written to the json. (For details, see the example
	/// below.)
	/// </summary>
	public bool Discover(bool onlyTokensPresent, JsonObject json)
	{
		int result = CkPkcs11U_DiscoverW(m_pObj, onlyTokensPresent == false ? 0 : 1, json == null ? System.IntPtr.Zero : json.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Finds all certificates contained on the smart card (or USB token). This sets the
	/// NumCerts property. Each certificate can be obtained by calling GetCert(index)
	/// where the 1st cert is at index 0.
	/// 
	/// Important: Private keys will not be seen unless the PKCS11 session is
	/// authenticated. To authenticate, your application must call Login after calling
	/// OpenSession.
	/// 
	///
	/// </summary>
	public bool FindAllCerts()
	{
		int result = CkPkcs11U_FindAllCertsW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Finds the certificate where the given certPart equals the partValue. Possible values for
	/// certPart are: "privateKey", "subjectDN", "subjectDN_withTags", "subjectCN",
	/// "serial", or "serial:issuerCN". If certPart equals "privateKey", then pass an empty
	/// string in partValue. Specifying "privateKey" means to return the first certificate
	/// having a private key.
	/// 
	/// The cert is loaded with the certificate if successful.
	/// 
	/// Important: Private keys will not be seen unless the PKCS11 session is
	/// authenticated. To authenticate, your application must call Login after calling
	/// OpenSession.
	/// 
	/// Note: If successful, the cert will be linked internally with this PKCS11 session
	/// such that certificate can be used for signing on the smart card when used in
	/// other Chilkat classes such as XmlDSigGen, Pdf, Crypt2, Mime, MailMan, etc.
	/// 
	///
	/// </summary>
	public bool FindCert(string certPart, string partValue, Cert cert)
	{
		int result = CkPkcs11U_FindCertW(m_pObj, certPart, partValue, cert == null ? System.IntPtr.Zero : cert.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads cert with the Nth certificate indicated by index. The 1st certificate is at
	/// index 0. The FindAllCerts method must be called beforehand to load the certs
	/// from the smart card into this object. After calling FindAllCerts, the NumCerts
	/// property is set and each certificate can be retrieved by calling GetCert.
	/// </summary>
	public bool GetCert(int index, Cert cert)
	{
		int result = CkPkcs11U_GetCertW(m_pObj, index, cert == null ? System.IntPtr.Zero : cert.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Initializes the PKCS#11 library. Should be called after specifying the
	/// SharedLibPath. The DLL (or .so/.dylib) is dynamically loaded and the PKCS#11 lib
	/// is initialized.
	/// </summary>
	public bool Initialize()
	{
		int result = CkPkcs11U_InitializeW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Initializes the normal user's PIN. This must be called from the security
	/// officer's (SO) logged-in session.
	/// 
	/// Note: To unblock a smart card, login to the SO (Security Officer) session using
	/// the PUK, and then call this with the new user PIN.
	/// 
	///
	/// </summary>
	public bool InitPin(string pin)
	{
		int result = CkPkcs11U_InitPinW(m_pObj, pin);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Initializes a token. slotId is the slot ID of the token's slot.
	/// 
	/// If the token has not been initialized (i.e. new from the factory), then the pPin
	/// parameter becomes the initial value of the SO (Security Officer) PIN. If the
	/// token is being reinitialized, the pin parameter is checked against the existing
	/// SO PIN to authorize the initialization operation.
	/// 
	/// When a token is initialized, all objects that can be destroyed are destroyed
	/// (i.e., all except for “indestructible” objects such as keys built into the
	/// token). Also, access by the normal user is disabled until the SO sets the normal
	/// user’s PIN. Depending on the token, some “default” objects may be created, and
	/// attributes of some objects may be set to default values.
	/// 
	///
	/// </summary>
	public bool InitToken(int slotId, string pin, string tokenLabel)
	{
		int result = CkPkcs11U_InitTokenW(m_pObj, slotId, pin, tokenLabel);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Authenticates a session with a PIN. The userType can be one of the following integer
	/// values:
	///     Security Officer (0)
	///     Normal User (1)
	///     Context Specific (2)
	/// 
	/// Except for special circumstances, you'll always login as the Normal User.
	/// 
	///
	/// </summary>
	public bool Login(int userType, string pin)
	{
		int result = CkPkcs11U_LoginW(m_pObj, userType, pin);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Logs out from a token (smart card).
	/// </summary>
	public bool Logout()
	{
		int result = CkPkcs11U_LogoutW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Opens a session on the token (i.e. smart card). The slotId is the ID of the slot
	/// (not the index). Set slotId equal to -1 to choose the first available non-empty
	/// slot. The readWrite indicates whether the session should be read-only or read-write.
	/// 
	/// The PKCS11 terminology is confusing:
	/// 
	///     A "slot" corresponds to a connected smart card reader or USB hardware token,
	///     such as a Feitian ePass3003Auto token.
	///     A "token" corresponds to the smart card inserted into the reader. If we have
	///     a USB hardware token, such as the epass3003Auto (or many others), then
	///     technically there is always a "smart card" inserted, because the USB hardware
	///     token is effectively both the reader and smart card wrapped in one inseparable
	///     device.
	///     The PKCS11 DLL (or .so shared lib, or .dylib) is the vendor supplied PKCS11
	///     implementation (driver) that provides the low-level "C" PKCS11 functions (called
	///     by Chilkat internally).
	///     Generally, the number of slots will equal the number of connected smart
	///     cards or tokens belonging to the vendor of the DLL, or compatible with the DLL.
	///     In most cases you'll have your single reader with a single smart card inserted,
	///     and therefore only one slot exists.
	///     Some PKCS11 DLLs are provided by a 3rd party and support many smart cards.
	///     For example, A.E.T. Europe B.V.'s "SafeSign Identity Client Standard Version
	///     3.5" DLL is "aetpkss1.dll". It supports the following tokens:
	///         Defensiepas
	///         Defensiepas 2
	///         G&amp;D Convego Join 4.01 40k/80k
	///         G&amp;D SkySIM Hercules
	///         G&amp;D SkySIM Scorpius
	///         G&amp;D Sm@rtCafé Expert 3.2
	///         G&amp;D Sm@rtCafé Expert 4.0
	///         G&amp;D Sm@rtCafé Expert 5.0
	///         G&amp;D Sm@rtCafé Expert 6.0
	///         G&amp;D Sm@rtCafé Expert 7.0
	///         G&amp;D Sm@rtCafé Expert 64
	///         Gemalto Desineo ICP D72 FXR1 Java
	///         Gemalto IDCore 30
	///         Gemalto MultiApp ID v2.1
	///         Gemalto Optelio D72 FR1
	///         Gemalto TOP DL v2
	///         Infineon Oracle JCOS Ed.1
	///         JCOP21 v2.3
	///         Morpho IDealCitiz v2.1
	///         Morpho JMV ProCL V3.0
	///         NXP J2A080 / J2A081 (JCOP 2.4.1 R3)
	///         NXP JD081 (JCOP 2.4.1 R3)
	///         NXP J3A080 (JCOP 2.4.1 R3)
	///         NXP JCOP 2.4.2 R3
	///         NXP JCOP 3 SecID P60
	///         Oberthur IDOne Cosmo v7.0
	///         RDW ABR kaart
	///         Rijkspas
	///         Rijkspas 2
	///         Sagem YpsID s2
	///         Sagem YpsID s3
	///         StarSign Crypto USB Token S
	///         Swissbit PS-100u SE
	///         UZI-pas
	///         UZI-pas 2
	///
	/// </summary>
	public bool OpenSession(int slotId, bool readWrite)
	{
		int result = CkPkcs11U_OpenSessionW(m_pObj, slotId, readWrite == false ? 0 : 1);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkPkcs11U_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Modifies the PIN of the user that is currently logged in, or the Normal User PIN
	/// if the session is not logged in.
	/// </summary>
	public bool SetPin(string oldPin, string newPin)
	{
		int result = CkPkcs11U_SetPinW(m_pObj, oldPin, newPin);
		return result == 0 ? false : true;
	}


	}
}

