using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class SocksProxy : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_Create2W", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkSocksProxyU_Create2W(int bCallbackOwned);

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkSocksProxyU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getAllowUnauthenticatedSocks5W", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getAllowUnauthenticatedSocks5W(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putAllowUnauthenticatedSocks5W", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putAllowUnauthenticatedSocks5W(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getAuthenticatedSocks5W", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getAuthenticatedSocks5W(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_clientIpW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_clientIpW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getClientPortW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getClientPortW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getConnectionPendingW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getConnectionPendingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_listenBindIpAddressW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_listenBindIpAddressW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putListenBindIpAddressW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putListenBindIpAddressW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_loginW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_loginW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_outboundBindIpAddressW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_outboundBindIpAddressW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putOutboundBindIpAddressW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putOutboundBindIpAddressW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getOutboundBindPortW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getOutboundBindPortW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putOutboundBindPortW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putOutboundBindPortW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_passwordW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_passwordW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_serverIpW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_serverIpW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getServerPortW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getServerPortW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getSocksVersionW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getSocksVersionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_AllowConnectionW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_AllowConnectionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_getTunnelsXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSocksProxyU_getTunnelsXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_InitializeW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_InitializeW(System.IntPtr pObj, int port);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_ProceedSocks5W", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_ProceedSocks5W(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_RejectConnectionW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_RejectConnectionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_StopAllTunnelsW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_StopAllTunnelsW(System.IntPtr pObj, int maxWaitMs);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_UnlockComponentW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_UnlockComponentW(System.IntPtr pObj, string unlockCode);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_WaitForConnectionW", CharSet = CharSet.Unicode)]
        private static extern int CkSocksProxyU_WaitForConnectionW(System.IntPtr pObj, int maxWaitMs);


		public SocksProxy()
		{
			m_pObj = CkSocksProxyU_Create2W(1);
			m_needDisposal = true;
		}

		public SocksProxy(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkSocksProxyU_DisposeW(p);
			}
		}

		~SocksProxy()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

        public delegate void AbortCheck([MarshalAs(UnmanagedType.Bool)] out bool abort);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_setFnAbortCheckW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_setFnAbortCheckW(System.IntPtr pObj, AbortCheck delegateFn);
	
        public void setAbortCheckCb(AbortCheck callbackObj)
        {
            CkSocksProxyU_setFnAbortCheckW(m_pObj, callbackObj);
        }

        public delegate void ProgressInfo([MarshalAs(UnmanagedType.LPWStr)]string name, [MarshalAs(UnmanagedType.LPWStr)]string value);
    
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSocksProxyU_setFnProgressInfoW", CharSet = CharSet.Unicode)]
        private static extern void CkSocksProxyU_setFnProgressInfoW(System.IntPtr pObj, ProgressInfo delegateFn);
	
        public void setProgressInfoCb(ProgressInfo callbackObj)
        {
            CkSocksProxyU_setFnProgressInfoW(m_pObj, callbackObj);
        }

	/// <summary>
	/// If true, unauthenticated SOCKS5 connections are allowed. If false, SOCKS5
	/// connections must provide a login/password. The default value is true.
	/// </summary>
	public bool AllowUnauthenticatedSocks5
	{
		get
		{
			return (CkSocksProxyU_getAllowUnauthenticatedSocks5W(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkSocksProxyU_putAllowUnauthenticatedSocks5W(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// true if the current pending connection is a SOCKS5 connection that provides a
	/// login/password. In this case, the Login and Password properties may be checked
	/// to determine if the connection should be allowed or rejected. If allowed, the
	/// ProceedSocks5 method should be called. Otherwise the RejectConnection method
	/// should be called.
	/// 
	/// A value of false indicates that the current pending connection is either
	/// SOCKS4 or unauthenticated SOCKS5.
	/// 
	///
	/// </summary>
	public bool AuthenticatedSocks5
	{
		get
		{
			return (CkSocksProxyU_getAuthenticatedSocks5W(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// The connecting client's IP address for the current pending connect request. For
	/// authenticated SOCKS5 connections, the client IP is not available until after the
	/// ProceedSocks5 method is called.
	/// </summary>
	public string ClientIp
	{
		get
		{
			return ckFromUni(CkSocksProxyU_clientIpW(m_pObj));
		}
	}

	/// <summary>
	/// The connecting client's bound port number for the current pending connect
	/// request. For authenticated SOCKS5 connections, this information is not available
	/// until after the ProceedSocks5 method is called.
	/// </summary>
	public int ClientPort
	{
		get
		{
			return CkSocksProxyU_getClientPortW(m_pObj);
		}
	}

	/// <summary>
	/// true if a connect request is pending after calling WaitForConnection.
	/// Otherwise false.
	/// </summary>
	public bool ConnectionPending
	{
		get
		{
			return (CkSocksProxyU_getConnectionPendingW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkSocksProxyU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkSocksProxyU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkSocksProxyU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkSocksProxyU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkSocksProxyU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// The IP address to use for computers with multiple network interfaces or IP
	/// addresses. For computers with a single network interface (i.e. most computers),
	/// this property should not be set. For multihoming computers, the default IP
	/// address is automatically used if this property is not set.
	/// 
	/// The IP address is a string such as in dotted notation using numbers, not domain
	/// names, such as "165.164.55.124".
	/// 
	/// Note: The listen port is specified as an argument in the Initialize method.
	/// 
	///
	/// </summary>
	public string ListenBindIpAddress
	{
		get
		{
			return ckFromUni(CkSocksProxyU_listenBindIpAddressW(m_pObj));
		}
		set
		{
			CkSocksProxyU_putListenBindIpAddressW(m_pObj, value);
		}
	}

	/// <summary>
	/// The login (username) provided by a connecting client when a connect request is
	/// in progress. Unauthenticated SOCKS5 connect requests do not provide a login or
	/// password. SOCKS4 connections provide a login (i.e. username), but no password.
	/// </summary>
	public string Login
	{
		get
		{
			return ckFromUni(CkSocksProxyU_loginW(m_pObj));
		}
	}

	/// <summary>
	/// The local bind IP address to use for outbound connections to a destination
	/// server. This property is for computers with multiple network interfaces or IP
	/// addresses. For computers with a single network interface (i.e. most computers),
	/// this property should not be set. For multihoming computers, the default IP
	/// address is automatically used if this property is not set.
	/// 
	/// The IP address is a string such as in dotted notation using numbers, not domain
	/// names, such as "165.164.55.124".
	/// 
	///
	/// </summary>
	public string OutboundBindIpAddress
	{
		get
		{
			return ckFromUni(CkSocksProxyU_outboundBindIpAddressW(m_pObj));
		}
		set
		{
			CkSocksProxyU_putOutboundBindIpAddressW(m_pObj, value);
		}
	}

	/// <summary>
	/// The local bind port to use for outbound connections to a destination server. In
	/// most cases this property should never be set. Do not set this property unless
	/// you know exactly what you are doing and you know that it is necessary.
	/// </summary>
	public int OutboundBindPort
	{
		get
		{
			return CkSocksProxyU_getOutboundBindPortW(m_pObj);
		}
		set
		{
			CkSocksProxyU_putOutboundBindPortW(m_pObj, value);
		}
	}

	/// <summary>
	/// The password sent by a connecting client during an authenticated SOCKS5
	/// connection.
	/// </summary>
	public string Password
	{
		get
		{
			return ckFromUni(CkSocksProxyU_passwordW(m_pObj));
		}
	}

	/// <summary>
	/// The destination server's IP address for the current pending connect request. For
	/// authenticated SOCKS5 connections, this information is not available until after
	/// the ProceedSocks5 method is called.
	/// </summary>
	public string ServerIp
	{
		get
		{
			return ckFromUni(CkSocksProxyU_serverIpW(m_pObj));
		}
	}

	/// <summary>
	/// The destination server's port for the current pending connect request. For
	/// authenticated SOCKS5 connections, this information is not available until after
	/// the ProceedSocks5 method is called.
	/// </summary>
	public int ServerPort
	{
		get
		{
			return CkSocksProxyU_getServerPortW(m_pObj);
		}
	}

	/// <summary>
	/// The SOCKS version of the current pending connect request. This property will
	/// have a value of 4 for SOCKS4 connections, and 5 for SOCKS5 connections.
	/// </summary>
	public int SocksVersion
	{
		get
		{
			return CkSocksProxyU_getSocksVersionW(m_pObj);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkSocksProxyU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkSocksProxyU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.4.1.42"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkSocksProxyU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// This is the final step in establishing a SOCKS5 tunnel. The SOCKS "handshake" is
	/// completed and the bi-directional SOCKS tunnel is managed in a background thread.
	/// All data arriving from the client is automatically forwarded to the server, and
	/// all data arriving from the server is automatically forwarded to the client.
	/// Regardless of how many SOCKS tunnels are active, they are all managed in a
	/// single background thread.
	/// </summary>
	public bool AllowConnection()
	{
		int result = CkSocksProxyU_AllowConnectionW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>

	/// </summary>
	public string GetTunnelsXml()
	{
		System.IntPtr result = CkSocksProxyU_getTunnelsXmlW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Initializes the SOCKS server to listen on a port. Both SOCKS4 and SOCKS5
	/// connections are handled by this component/class.
	/// </summary>
	public bool Initialize(int port)
	{
		int result = CkSocksProxyU_InitializeW(m_pObj, port);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// This method should be called after receiving an authenticated SOCKS5 connection
	/// and verifying the Login and Password. It sends an "authentication accepted"
	/// message to the SOCKS5 client and proceeds to the next step in the SOCKS5
	/// "handshake". If ProceedSocks5 returns true, the following properties will
	/// contain valid data: ClientIp, ClientPort, ServerIp, ServerPort. If ProceedSocks5
	/// returns false it means that the connection with the client has ended.
	/// </summary>
	public bool ProceedSocks5()
	{
		int result = CkSocksProxyU_ProceedSocks5W(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Rejects a client connection and closes the connection with the client.
	/// </summary>
	public bool RejectConnection()
	{
		int result = CkSocksProxyU_RejectConnectionW(m_pObj);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkSocksProxyU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>

	/// </summary>
	public bool StopAllTunnels(int maxWaitMs)
	{
		int result = CkSocksProxyU_StopAllTunnelsW(m_pObj, maxWaitMs);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Unlocks the component allowing for the full functionality to be used. An
	/// arbitrary string can be passed to initiate a fully-functional 30-day trial.
	/// </summary>
	public bool UnlockComponent(string unlockCode)
	{
		int result = CkSocksProxyU_UnlockComponentW(m_pObj, unlockCode);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Waits for an incoming SOCKS4 or SOCKS5 connection. The maximum number of
	/// milliseconds to way is specified by maxWaitMs. Passing a value of 0 for maxWaitMs causes
	/// the method to wait indefinitely. Returns true if a connection was received or
	/// if a timeout occurred. To distinguish between a timeout and a pending connect
	/// request, check the ConnectionPending property. If ConnectionPending is true,
	/// then a client connection is waiting to be accepted/rejected. Otherwise it was a
	/// timeout. A return value of false indicates a more serious problem where it's
	/// best to examine the contents of the LastErrorText property.
	/// 
	/// If a connection is pending, the next step is to examine the various properties
	/// about the connect request to determine if it should be accepted or rejected. The
	/// SocksVersion property tells whether it's a SOCKS4 or SOCKS5 connection. If a
	/// SOCKS4 connection is received, the following properties are set: ClientIp,
	/// ClientPort, ServerIp, ServerPort, Login. Your program should proceed by calling
	/// AllowConnection or RejectConnection.
	/// 
	/// If a SOCKS5 connection is received, check the AuthenticatedSocks5 property to
	/// determine if the client is providing a login/password. If so, then the Login and
	/// Password properties have this information. If valid, your application should
	/// continue the SOCKS5 connection by calling ProceedSocks5. Otherwise the
	/// connection should be rejected immediately by calling RejectConnection.
	/// 
	/// For SOCKS5, the ClientIp, ClientPort, ServerIp, and ServerPort properties are
	/// set immediately after WaitForConnection returns for unauthenticated SOCKS5
	/// connections, or after ProceedSocks5 returns for authenticated SOCKS5. These
	/// properties may be examined to accept or reject the connection. Call
	/// AllowConnection to allow, or RejectConnection to reject.
	/// 
	/// Note: If the AllowUnauthenticatedSocks5 property is set to false, then
	/// unauthenicated SOCKS5 connections are automatically rejected. (In other words,
	/// WaitForConnection will never return an unauthenticated connection attempt and
	/// will instead automatically reject it and continue waiting for the next incoming
	/// connection.)
	/// 
	///
	/// </summary>
	public bool WaitForConnection(int maxWaitMs)
	{
		int result = CkSocksProxyU_WaitForConnectionW(m_pObj, maxWaitMs);
		return result == 0 ? false : true;
	}


	}
}

